GNU bug report logs - #10125
24.0.91; package.el (org): Macros in tar packages & order of byte compilation

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Jambunathan K <kjambunathan@HIDDEN>; merged with #18443, #18448, #21267; dated Thu, 24 Nov 2011 12:15:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Merged 10125 18443 18448 21267. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Merged 10125 18443 18448. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Forcibly Merged 10125 18443. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.

Message received at 10125-done <at> debbugs.gnu.org:


Received: (at 10125-done) by debbugs.gnu.org; 15 Nov 2013 04:00:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 14 23:00:41 2013
Received: from localhost ([127.0.0.1]:53023 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1VhAaG-0008Ek-RY
	for submit <at> debbugs.gnu.org; Thu, 14 Nov 2013 23:00:41 -0500
Received: from mail-pd0-f179.google.com ([209.85.192.179]:39166)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kjambunathan@HIDDEN>) id 1VhAaD-0008EU-Of
 for 10125-done <at> debbugs.gnu.org; Thu, 14 Nov 2013 23:00:38 -0500
Received: by mail-pd0-f179.google.com with SMTP id r10so10010pdi.38
 for <10125-done <at> debbugs.gnu.org>; Thu, 14 Nov 2013 20:00:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-type;
 bh=zC3exQV7gQymnvEcxBkBcCBwNKZCPjyUEUQ3qPQK9fA=;
 b=Yt3A2/T+Cnd6DmhWa/0dHQwohSkilL001z/glysnWl1kfmVOr5bmNN/eeDmggqT7wZ
 zG4GpSfNSdm3an63J9QAbi/o1hLw4lHxspgm0H2huXa+QQZtgFaJgKKBaWuql994kRgr
 sks02SMyzn5NCMban0iKafWTZdtbOpKP6m/cdid6cJM5f51KXgrUvcSfBQMAEGwmolzp
 ZN4kZdBuRhM5hvz0+1Ou/NWgmLxx4sFwEdXcplCzEfbln91YtPkhEdB5Q7Oh0utKC9HH
 vHF+GlrYq0CjtgkodXnxDClOs2/FumcPb0gOGM6u7uf1GMCEpz3yqzhx8xTaUd2LnODE
 kmaQ==
X-Received: by 10.68.34.132 with SMTP id z4mr3472486pbi.56.1384488031689;
 Thu, 14 Nov 2013 20:00:31 -0800 (PST)
Received: from debian-6.05 ([101.63.165.167])
 by mx.google.com with ESMTPSA id pl1sm1218512pbb.20.2013.11.14.20.00.29
 for <multiple recipients>
 (version=TLSv1.1 cipher=RC4-SHA bits=128/128);
 Thu, 14 Nov 2013 20:00:31 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: 10125-done <at> debbugs.gnu.org
Subject: Re: bug#10125: 24.0.91;
 package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN>
Date: Tue, 01 Jan 2002 06:03:31 +0530
In-Reply-To: <81pqgh90sp.fsf@HIDDEN> (Jambunathan K.'s message of "Thu, 24
 Nov 2011 17:42:38 +0530")
Message-ID: <871yhayko4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: This is one of the most frequently reported problems in Org
 mailing list. This is also one of the problems that the current maintainer
 understands very poorly. Anyways closing the bug as OP. [...] 
 Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 FREEMAIL_FROM Sender email is commonly abused enduser mail provider
 (kjambunathan[at]gmail.com)
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
 trust [209.85.192.179 listed in list.dnswl.org]
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received: date
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 T_DKIM_INVALID         DKIM-Signature header exists but is not valid
X-Debbugs-Envelope-To: 10125-done
Cc: emacs-orgmode@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  This is one of the most frequently reported problems in Org
    mailing list. This is also one of the problems that the current maintainer
    understands very poorly. Anyways closing the bug as OP. [...] 
 
 Content analysis details:   (2.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [209.85.192.179 listed in list.dnswl.org]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail provider
                             (kjambunathan[at]gmail.com)
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received: date
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 T_DKIM_INVALID         DKIM-Signature header exists but is not valid


This is one of the most frequently reported problems in Org mailing
list.  This is also one of the problems that the current maintainer
understands very poorly.

Anyways closing the bug as OP.




Notification sent to Jambunathan K <kjambunathan@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Jambunathan K <kjambunathan@HIDDEN>:
You have taken responsibility. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Jan 2013 15:46:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 16 10:46:36 2013
Received: from localhost ([127.0.0.1]:35439 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TvVCF-000587-Tr
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 10:46:36 -0500
Received: from eggs.gnu.org ([208.118.235.92]:46930)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvVCC-00057y-V7
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 10:46:33 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvVBc-000491-1l
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 10:45:56 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_NONE, RP_MATCHES_RCVD,
	USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:53949)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvVBb-00048r-Um
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 10:45:55 -0500
Received: from eggs.gnu.org ([208.118.235.92]:58255)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvVBW-0000aE-8M
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 10:45:55 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvVBR-00047M-Bn
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 10:45:50 -0500
Received: from plane.gmane.org ([80.91.229.3]:59110)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvURg-0007tY-63
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 09:58:28 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvURt-0003he-CT
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 15:58:41 +0100
Received: from c-71-237-25-24.hsd1.co.comcast.net ([71.237.25.24])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Wed, 16 Jan 2013 15:58:41 +0100
Received: from kevin.d.rodgers by c-71-237-25-24.hsd1.co.comcast.net with
	local (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Wed, 16 Jan 2013 15:58:41 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Kevin Rodgers <kevin.d.rodgers@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Wed, 16 Jan 2013 07:59:23 -0700
Lines: 21
Message-ID: <kd6f64$h8r$1@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN>
	<mthamoy574.fsf@HIDDEN>	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>	<87wqvjd7qa.fsf@HIDDEN>	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>	<87bocvcx9f.fsf@HIDDEN>	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
	<83ip72u89o.fsf@HIDDEN>	<87ehhqn1md.fsf@HIDDEN>
	<8338y6txjh.fsf@HIDDEN>	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>	<71vcb22qgz.fsf__38024.2966501557$1358016217$gmane$org@HIDDEN>	<87hamlbk3w.fsf__41794.7558024482$1358063310$gmane$org@HIDDEN>	<87hamis0js.fsf@HIDDEN>
	<kd5spq$1hh$1@HIDDEN> <mvmtxqh5tn0.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-71-237-25-24.hsd1.co.comcast.net
User-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.4; en-US;
	rv:1.9.2.28) Gecko/20120306 Thunderbird/3.1.20
In-Reply-To: <mvmtxqh5tn0.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

On 1/16/13 3:06 AM, Andreas Schwab wrote:
> Kevin Rodgers<kevin.d.rodgers@HIDDEN>  writes:
>
>> (defun run-emacs (command)
>>    "Run the Emacs COMMAND in the background via `shell-command'."
>>    (interactive
>>     (let ((program (expand-file-name invocation-name invocation-directory)))
>>       (list (read-string "Emacs command: "
>> 			(cons (concat program
>> 				      (if (cdr command-line-args)
>> 					  (mapconcat 'identity
>> 						     (cdr command-line-args)
>
> You need to use shell-quote-argument to properly shell-quote each
> argument.

Thanks, Andreas!

-- 
Kevin Rodgers
Denver, Colorado, USA





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 16 Jan 2013 10:07:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 16 05:07:27 2013
Received: from localhost ([127.0.0.1]:34558 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TvPu2-0004s3-QB
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 05:07:27 -0500
Received: from mail-out.m-online.net ([212.18.0.9]:47437)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1TvPtz-0004ru-7K
	for 10125 <at> debbugs.gnu.org; Wed, 16 Jan 2013 05:07:24 -0500
Received: from frontend1.mail.m-online.net (unknown [192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3YmPGH75h9z4KK9p;
	Wed, 16 Jan 2013 11:06:47 +0100 (CET)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.68])
	by mail.m-online.net (Postfix) with ESMTP id 3YmPGH6GrnzbbhF;
	Wed, 16 Jan 2013 11:06:47 +0100 (CET)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.180])
	by localhost (dynscan1.mail.m-online.net [192.168.6.68]) (amavisd-new,
	port 10024)
	with ESMTP id dIvwtGMkTiYX; Wed, 16 Jan 2013 11:06:27 +0100 (CET)
X-Auth-Info: N35M63L3yiZbcOcc1qcaTYsh1/MxOBlVkeTm/RS3A5o=
Received: from hawking.suse.de (nat.nue.novell.com [195.135.221.2])
	(using TLSv1 with cipher DHE-RSA-AES128-SHA (128/128 bits))
	(No client certificate requested)
	by mail.mnet-online.de (Postfix) with ESMTPSA;
	Wed, 16 Jan 2013 11:06:43 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Kevin Rodgers <kevin.d.rodgers@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<71vcb22qgz.fsf__38024.2966501557$1358016217$gmane$org@HIDDEN>
	<87hamlbk3w.fsf__41794.7558024482$1358063310$gmane$org@HIDDEN>
	<87hamis0js.fsf@HIDDEN> <kd5spq$1hh$1@HIDDEN>
X-Yow: Oh my GOD -- the SUN just fell into YANKEE STADIUM!!
Date: Wed, 16 Jan 2013 11:06:43 +0100
In-Reply-To: <kd5spq$1hh$1@HIDDEN> (Kevin Rodgers's message of "Wed, 16
	Jan 2013 02:45:36 -0700")
Message-ID: <mvmtxqh5tn0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

Kevin Rodgers <kevin.d.rodgers@HIDDEN> writes:

> (defun run-emacs (command)
>   "Run the Emacs COMMAND in the background via `shell-command'."
>   (interactive
>    (let ((program (expand-file-name invocation-name invocation-directory)))
>      (list (read-string "Emacs command: "
> 			(cons (concat program
> 				      (if (cdr command-line-args)
> 					  (mapconcat 'identity
> 						     (cdr command-line-args)

You need to use shell-quote-argument to properly shell-quote each
argument.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Jan 2013 09:45:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 16 04:45:20 2013
Received: from localhost ([127.0.0.1]:34528 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TvPYe-0004Lx-3s
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 04:45:20 -0500
Received: from eggs.gnu.org ([208.118.235.92]:38309)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPYb-0004Lp-U9
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 04:45:18 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPY2-0001h3-Kl
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 04:44:43 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_NONE, RP_MATCHES_RCVD,
	USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:45182)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPY2-0001gz-Hi
	for submit <at> debbugs.gnu.org; Wed, 16 Jan 2013 04:44:42 -0500
Received: from eggs.gnu.org ([208.118.235.92]:49671)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPY1-0005Xi-KG
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 04:44:42 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPY0-0001ge-Ch
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 04:44:41 -0500
Received: from plane.gmane.org ([80.91.229.3]:41217)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPY0-0001gV-5U
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 04:44:40 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvPYE-0002P8-U7
	for bug-gnu-emacs@HIDDEN; Wed, 16 Jan 2013 10:44:54 +0100
Received: from c-71-237-25-24.hsd1.co.comcast.net ([71.237.25.24])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Wed, 16 Jan 2013 10:44:54 +0100
Received: from kevin.d.rodgers by c-71-237-25-24.hsd1.co.comcast.net with
	local (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Wed, 16 Jan 2013 10:44:54 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Kevin Rodgers <kevin.d.rodgers@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Wed, 16 Jan 2013 02:45:36 -0700
Lines: 27
Message-ID: <kd5spq$1hh$1@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN>
	<mthamoy574.fsf@HIDDEN>	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>	<87wqvjd7qa.fsf@HIDDEN>	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>	<87bocvcx9f.fsf@HIDDEN>	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
	<83ip72u89o.fsf@HIDDEN>	<87ehhqn1md.fsf@HIDDEN>
	<8338y6txjh.fsf@HIDDEN>	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>	<71vcb22qgz.fsf__38024.2966501557$1358016217$gmane$org@HIDDEN>	<87hamlbk3w.fsf__41794.7558024482$1358063310$gmane$org@HIDDEN>
	<87hamis0js.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-71-237-25-24.hsd1.co.comcast.net
User-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.4; en-US;
	rv:1.9.2.28) Gecko/20120306 Thunderbird/3.1.20
In-Reply-To: <87hamis0js.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

On 1/15/13 12:34 PM, Achim Gratz wrote:
> Achim Gratz writes:
>> +               (concat invocation-directory invocation-name)
>
> Better make that
> +               (expand-file-name invocation-name invocation-directory)

FWIW here's what I use:

(defun run-emacs (command)
   "Run the Emacs COMMAND in the background via `shell-command'."
   (interactive
    (let ((program (expand-file-name invocation-name invocation-directory)))
      (list (read-string "Emacs command: "
			(cons (concat program
				      (if (cdr command-line-args)
					  (mapconcat 'identity
						     (cdr command-line-args)
						     " ")
					" -Q")
				      " &")
			      (1+ (length program)))))))
   (shell-command command))

-- 
Kevin Rodgers
Denver, Colorado, USA





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 Jan 2013 19:35:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 15 14:35:11 2013
Received: from localhost ([127.0.0.1]:33806 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TvCHv-0006vx-CS
	for submit <at> debbugs.gnu.org; Tue, 15 Jan 2013 14:35:11 -0500
Received: from eggs.gnu.org ([208.118.235.92]:59694)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHs-0006vq-VR
	for submit <at> debbugs.gnu.org; Tue, 15 Jan 2013 14:35:09 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHM-00070B-KH
	for submit <at> debbugs.gnu.org; Tue, 15 Jan 2013 14:34:37 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:39001)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHM-000707-HR
	for submit <at> debbugs.gnu.org; Tue, 15 Jan 2013 14:34:36 -0500
Received: from eggs.gnu.org ([208.118.235.92]:42812)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHK-0002ju-4i
	for bug-gnu-emacs@HIDDEN; Tue, 15 Jan 2013 14:34:36 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHI-0006zK-43
	for bug-gnu-emacs@HIDDEN; Tue, 15 Jan 2013 14:34:34 -0500
Received: from plane.gmane.org ([80.91.229.3]:38218)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHH-0006zA-Tg
	for bug-gnu-emacs@HIDDEN; Tue, 15 Jan 2013 14:34:32 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TvCHU-0007hl-M1
	for bug-gnu-emacs@HIDDEN; Tue, 15 Jan 2013 20:34:44 +0100
Received: from pd9eb5dc1.dip.t-dialin.net ([217.235.93.193])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Tue, 15 Jan 2013 20:34:44 +0100
Received: from Stromeko by pd9eb5dc1.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Tue, 15 Jan 2013 20:34:44 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Tue, 15 Jan 2013 20:34:15 +0100
Organization: Linux Private Site
Lines: 13
Message-ID: <87hamis0js.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<71vcb22qgz.fsf__38024.2966501557$1358016217$gmane$org@HIDDEN>
	<87hamlbk3w.fsf__41794.7558024482$1358063310$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb5dc1.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
Cancel-Lock: sha1:NpskV3lghu51ESjq1DQAYfrwbBA=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Achim Gratz writes:
> +               (concat invocation-directory invocation-name)

Better make that 
+               (expand-file-name invocation-name invocation-directory)

Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Terratec KOMPLEXER:
http://Synth.Stromeko.net/Downloads.html#KomplexerWaves





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Jan 2013 07:53:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 13 02:53:55 2013
Received: from localhost ([127.0.0.1]:57592 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TuIOA-0008AP-Lc
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:53:54 -0500
Received: from eggs.gnu.org ([208.118.235.92]:57950)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIO8-0008AC-AO
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:53:53 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINc-0000NS-Ir
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:53:30 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:44893)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINc-0000NN-Ei
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:53:20 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40940)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINU-0007yA-AK
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:53:20 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINM-0000J5-Ll
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:53:11 -0500
Received: from plane.gmane.org ([80.91.229.3]:39263)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINM-0000J1-CE
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:53:04 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuINT-00066f-E8
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 08:53:11 +0100
Received: from pd9eb28c8.dip.t-dialin.net ([217.235.40.200])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sun, 13 Jan 2013 08:53:11 +0100
Received: from Stromeko by pd9eb28c8.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sun, 13 Jan 2013 08:53:11 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sun, 13 Jan 2013 08:52:45 +0100
Organization: Linux Private Site
Lines: 18
Message-ID: <87d2x9bjua.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<83wqvisdxx.fsf__30242.1131091707$1357998993$gmane$org@HIDDEN>
	<87ip72fi8f.fsf@HIDDEN>
	<83fw26s0sl.fsf__44536.8833411068$1358016038$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb28c8.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
Cancel-Lock: sha1:VNMkG+a9OfgOUJqzdLFp8G6wdOY=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -5.5 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Eli Zaretskii writes:
> Sorry, I don't follow: new packages can only affect "emacs -Q" if you
> re-dump Emacs in between.  Am I missing something?

No, for package manager "emacs -Q" should work well enough.  The
fork/spawn thing might still be useful to make this more efficient or
(if you allow to create such fork points programmatically) to enable
Emacs to easily backtrack to some earlier state.  But that should be
discussed in emacs-devel under a different headline.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Terratec KOMPLEXER:
http://Synth.Stromeko.net/Downloads.html#KomplexerWaves





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Jan 2013 07:47:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 13 02:47:51 2013
Received: from localhost ([127.0.0.1]:57586 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TuIII-00081J-BB
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:47:51 -0500
Received: from eggs.gnu.org ([208.118.235.92]:57316)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIIF-000815-Gk
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:47:48 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIHr-0007UK-Uv
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:47:25 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:43538)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIHr-0007UG-Rb
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 02:47:23 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40438)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIHo-0006gi-Ra
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:47:23 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIHn-0007TU-0X
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:47:20 -0500
Received: from plane.gmane.org ([80.91.229.3]:49082)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuIHm-0007TQ-Ph
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 02:47:18 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TuII0-00027T-8x
	for bug-gnu-emacs@HIDDEN; Sun, 13 Jan 2013 08:47:32 +0100
Received: from pd9eb28c8.dip.t-dialin.net ([217.235.40.200])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sun, 13 Jan 2013 08:47:32 +0100
Received: from Stromeko by pd9eb28c8.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sun, 13 Jan 2013 08:47:32 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sun, 13 Jan 2013 08:46:59 +0100
Organization: Linux Private Site
Lines: 54
Message-ID: <87hamlbk3w.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<71vcb22qgz.fsf__38024.2966501557$1358016217$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb28c8.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
Cancel-Lock: sha1:m76OupLJU84iiotrXMDt3t9ZJro=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Glenn Morris writes:
> http://debbugs.gnu.org/cgi/bugreport.cgi?bug=10125#50
>
>    Turns out I was looking for invocation-directory and invocation-name.

Indeed, thanks.  So using your earlier patch as a template, this should
be good for emacs-24:

--8<---------------cut here---------------start------------->8---
diff --git a/lisp/emacs-lisp/package.el b/lisp/emacs-lisp/package.el
index 6059f03..df194b8 100644
--- a/lisp/emacs-lisp/package.el
+++ b/lisp/emacs-lisp/package.el
@@ -632,11 +632,20 @@ untar into a directory named DIR; otherwise, signal an error."
   "Generate autoloads and do byte-compilation for package named NAME.
 PKG-DIR is the name of the package directory."
   (package-generate-autoloads name pkg-dir)
-  (let ((load-path (cons pkg-dir load-path)))
-    ;; We must load the autoloads file before byte compiling, in
-    ;; case there are magic cookies to set up non-trivial paths.
-    (load (expand-file-name (concat name "-autoloads") pkg-dir) nil t)
-    (byte-recompile-directory pkg-dir 0 t)))
+  (with-current-buffer (get-buffer-create "*package-compile*")
+    (goto-char (point-max))
+    (pop-to-buffer (current-buffer))
+    (or (zerop (call-process
+               (concat invocation-directory invocation-name)
+               nil t t "--batch" "-Q" "--eval"
+               (format
+                "(let ((pkg-dir \"%s\")(name \"%s\"))
+                    (progn (setq load-path (cons pkg-dir load-path))
+                    (load (expand-file-name (concat name \"-autoloads\") pkg-dir) nil t)
+                    (batch-byte-recompile-directory 0)))"
+                pkg-dir name)
+               pkg-dir))
+       (error "Compiling the package gave an error"))))
 
 (defun package--write-file-no-coding (file-name)
   (let ((buffer-file-coding-system 'no-conversion))
--8<---------------cut here---------------end--------------->8---

I've confirmed that Emacs 24.2 fails to install current Org from ELPA
without that patch when trying to install after having opened an Org
file.  It installs Org correctly in that same situation with the patch
that does the package compilation in an external Emacs process.


Regards
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf rackAttack:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 18:42:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 13:42:25 2013
Received: from localhost ([127.0.0.1]:57242 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu62B-0005aZ-Pn
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 13:42:25 -0500
Received: from fencepost.gnu.org ([208.118.235.10]:51108 ident=Debian-exim)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rgm@HIDDEN>) id 1Tu628-0005aR-TI
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 13:42:21 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1Tu61s-0006Mq-5s; Sat, 12 Jan 2013 13:42:04 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
X-Spook: Pine Gap embassy CNCIS MP5K-SD Khaddafi explosion CIDA
X-Ran: |hWG>fZ78~lto?N<vCOm5v"9A7VK7wT29z@U>D[Yt,{rAx}B_~'T#dU[0u>?TTCi4$?_Q~
X-Hue: yellow
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Sat, 12 Jan 2013 13:42:04 -0500
In-Reply-To: <jwvehhqy1k8.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Sat, 12 Jan 2013 08:28:29 -0500")
Message-ID: <71vcb22qgz.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: 10125
Cc: Eli Zaretskii <eliz@HIDDEN>, Achim Gratz <Stromeko@HIDDEN>,
	10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Stefan Monnier wrote:

>> IOW, do you expect the byte-compile instances to be different in any
>> way from a fresh Emacs session invoked from the shell as "emacs -Q"?
>
> Yes, because the current Emacs may be a different executable than the
> one the shell would run in response to "emacs -Q".

http://debbugs.gnu.org/cgi/bugreport.cgi?bug=10125#50

   Turns out I was looking for invocation-directory and invocation-name.

If you want to worry about wacky things like a new Emacs having been
installed on top of the old in the meantime, more power to you.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 18:39:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 13:39:51 2013
Received: from localhost ([127.0.0.1]:57238 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu5zj-0005Wa-8r
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 13:39:51 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:62245)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1Tu5zh-0005WL-2j
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 13:39:50 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MGI00100ZSU8Y00@HIDDEN> for
	10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 20:39:29 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MGI001M6ZTT5J40@HIDDEN>;
	Sat, 12 Jan 2013 20:39:29 +0200 (IST)
Date: Sat, 12 Jan 2013 20:39:54 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-reply-to: <87ip72fi8f.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Achim Gratz <Stromeko@HIDDEN>
Message-id: <83fw26s0sl.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
	<83ip72u89o.fsf@HIDDEN> <87ehhqn1md.fsf@HIDDEN>
	<8338y6txjh.fsf@HIDDEN> <jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<83wqvisdxx.fsf__30242.1131091707$1357998993$gmane$org@HIDDEN>
	<87ip72fi8f.fsf@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  > From: Achim Gratz <Stromeko@HIDDEN> > Date: Sat,
	12 Jan 2013 18:01:36 +0100 > > Eli Zaretskii writes: > >> > IOW,
	do you expect the
	byte-compile instances to be different in any > >> > way from a fresh
	Emacs
	session invoked from the shell as "emacs -Q"? > >> > >> Yes, because the
	current Emacs may be a different executable than the > >> one the shell
	would
	run in response to "emacs -Q". > > > > And if we make sure the same
	executable
	is run (easy on Windows)? Are > > there any other differences? > >
	There
	may have been changes in the way Emacs starts up in the meantime,
	> since
	we're considering the case where new packages get installed. > Starting
	Emacs
	with "-Q" shouldn't be affected by this, but there's no > guarantee (yes,
	this is a fringe case). [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.4510]
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.7 (/)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Sat, 12 Jan 2013 18:01:36 +0100
> 
> Eli Zaretskii writes:
> >> > IOW, do you expect the byte-compile instances to be different in any
> >> > way from a fresh Emacs session invoked from the shell as "emacs -Q"?
> >> 
> >> Yes, because the current Emacs may be a different executable than the
> >> one the shell would run in response to "emacs -Q".
> >
> > And if we make sure the same executable is run (easy on Windows)?  Are
> > there any other differences?
> 
> There may have been changes in the way Emacs starts up in the meantime,
> since we're considering the case where new packages get installed.
> Starting Emacs with "-Q" shouldn't be affected by this, but there's no
> guarantee (yes, this is a fringe case).

Sorry, I don't follow: new packages can only affect "emacs -Q" if you
re-dump Emacs in between.  Am I missing something?




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 17:34:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 12:34:50 2013
Received: from localhost ([127.0.0.1]:57173 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu4yn-0003x8-UY
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:34:50 -0500
Received: from mail-wi0-f171.google.com ([209.85.212.171]:61709)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bastienguerry@HIDDEN>) id 1Tu4yl-0003ww-Lp
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:34:48 -0500
Received: by mail-wi0-f171.google.com with SMTP id hn14so460211wib.4
	for <10125 <at> debbugs.gnu.org>; Sat, 12 Jan 2013 09:34:28 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:sender:from:to:cc:subject:in-reply-to:references
	:user-agent:date:message-id:mime-version:content-type;
	bh=ToEtExjiNlT0Nklt6FTP6Pi/yHkH7ARNw0IRXY7pDRA=;
	b=Q8ouWticoIjzGlCKcFkWIIwxR4kuPxvWItCs+/VMFF7UiEHBb00MwIxY3TAQBV1Tlg
	woIUAK0o+gi9DshfAOU7PDqFDe3+7ht3FzWEnGlUBbiD9Ajnzocia+WoYtqODHLvV2Kx
	w7YtCqAdkQHcoL6JUTXBI1IiA8v9myj5hBAnHxXkHU8L217eBaXRGLrAq35PxukV2Odc
	L//Wmk0hlqEH8nJK6J09HZ1asTg7MNxROZngezpXdqpjvHRhnsHii0mCHgUJHTPxCExi
	Mdr3gFPBJ2nOVIbeaZD6YbcUOg6KpvQgYUdl3P0rYfhuavjFqBQxLuhqVa++IY2OY2sG
	SdGg==
X-Received: by 10.194.78.207 with SMTP id d15mr127179516wjx.52.1358012068323; 
	Sat, 12 Jan 2013 09:34:28 -0800 (PST)
Received: from bzg.localdomain (mar75-2-81-56-68-112.fbx.proxad.net.
	[81.56.68.112])
	by mx.google.com with ESMTPS id s10sm5039672wiw.4.2013.01.12.09.34.26
	(version=TLSv1.1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Sat, 12 Jan 2013 09:34:27 -0800 (PST)
Received: by bzg.localdomain (Postfix, from userid 1000)
	id 7E08B1C20555; Sat, 12 Jan 2013 18:34:26 +0100 (CET)
From: Bastien <bzg@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-Reply-To: <jwv6232wfcu.fsf-monnier+emacs__17509.4642596834$1358007214$gmane$org@HIDDEN>
	(Stefan Monnier's message of "Sat, 12 Jan 2013 11:12:24 -0500")
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN> <87hamm8qze.fsf@HIDDEN>
	<jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN> <87liby7a57.fsf@HIDDEN>
	<jwv6232wfcu.fsf-monnier+emacs__17509.4642596834$1358007214$gmane$org@HIDDEN>
User-Agent: Gnus/5.130006 (Ma Gnus v0.6) Emacs/24.3.50 (gnu/linux)
Date: Sat, 12 Jan 2013 18:34:26 +0100
Message-ID: <871udqmhjx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Stefan Monnier <monnier@HIDDEN> writes:

>> In that case, isn't it enough to call (package-initialize) before
>> any Org configuration?
>
> Here's the scenario:
>
> start Emacs
> use Org
> use package.el to install a newer version of Org

I see, thanks.

-- 
 Bastien




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Jan 2013 17:02:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 12:02:33 2013
Received: from localhost ([127.0.0.1]:57161 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu4TZ-0003Ch-9R
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:02:33 -0500
Received: from eggs.gnu.org ([208.118.235.92]:33842)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4TX-0003CT-2w
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:02:32 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4T9-0008Rb-4M
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:02:12 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:32877)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4T9-0008RX-2R
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 12:02:07 -0500
Received: from eggs.gnu.org ([208.118.235.92]:45147)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4T1-0001GW-7v
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 12:02:07 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4Su-0008PG-QK
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 12:01:59 -0500
Received: from plane.gmane.org ([80.91.229.3]:59001)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4Su-0008P6-JY
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 12:01:52 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu4T7-0005nT-Lx
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 18:02:05 +0100
Received: from pd9eb5715.dip.t-dialin.net ([217.235.87.21])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 18:02:05 +0100
Received: from Stromeko by pd9eb5715.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 18:02:05 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sat, 12 Jan 2013 18:01:36 +0100
Organization: Linux Private Site
Lines: 23
Message-ID: <87ip72fi8f.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
	<jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
	<83wqvisdxx.fsf__30242.1131091707$1357998993$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb5715.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
Cancel-Lock: sha1:cCbDMU9BFctDjS8Es3n9Ih/4xkc=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Eli Zaretskii writes:
>> > IOW, do you expect the byte-compile instances to be different in any
>> > way from a fresh Emacs session invoked from the shell as "emacs -Q"?
>> 
>> Yes, because the current Emacs may be a different executable than the
>> one the shell would run in response to "emacs -Q".
>
> And if we make sure the same executable is run (easy on Windows)?  Are
> there any other differences?

There may have been changes in the way Emacs starts up in the meantime,
since we're considering the case where new packages get installed.
Starting Emacs with "-Q" shouldn't be affected by this, but there's no
guarantee (yes, this is a fringe case).


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptations for KORG EX-800 and Poly-800MkII V0.9:
http://Synth.Stromeko.net/Downloads.html#KorgSDada





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Jan 2013 16:30:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 11:30:28 2013
Received: from localhost ([127.0.0.1]:57125 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu3yU-0002RX-Kr
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:30:27 -0500
Received: from eggs.gnu.org ([208.118.235.92]:56974)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3yR-0002RI-8G
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:30:24 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3y1-0008P6-Ie
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:30:02 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:46954)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3y1-0008Oz-Fz
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:29:57 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40066)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3xx-0007dL-6B
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 11:29:57 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3xs-0008Nk-Uz
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 11:29:53 -0500
Received: from plane.gmane.org ([80.91.229.3]:42777)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3xs-0008N2-OL
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 11:29:48 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tu3y6-0005kI-NM
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 17:30:02 +0100
Received: from pd9eb5715.dip.t-dialin.net ([217.235.87.21])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 17:30:02 +0100
Received: from Stromeko by pd9eb5715.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 17:30:02 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sat, 12 Jan 2013 17:29:38 +0100
Organization: Linux Private Site
Lines: 20
Message-ID: <87r4lqfjpp.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN> <87hamm8qze.fsf@HIDDEN>
	<jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN> <87liby7a57.fsf@HIDDEN>
	<jwv6232wfcu.fsf-monnier+emacs@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb5715.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.92 (gnu/linux)
Cancel-Lock: sha1:CgighxHisVXT3SRWuEvsPXRcgr8=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Stefan Monnier writes:
>> In that case, isn't it enough to call (package-initialize) before
>> any Org configuration?
>
> Here's the scenario:
>
> start Emacs
> use Org
> use package.el to install a newer version of Org

Exactly.  Thanks for putting it so succinctly.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptation for Waldorf Blofeld V1.15B11:
http://Synth.Stromeko.net/Downloads.html#WaldorfSDada





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 16:12:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 11:12:45 2013
Received: from localhost ([127.0.0.1]:57112 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu3hN-00020x-4o
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:12:45 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:15245)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Tu3hL-00020m-8A
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 11:12:43 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09FpZpV/2dsb2JhbABEgXuyFoEIghUBAQQBViMFCws0EhQYDSSIHAW6CZBEA4hCmnGBWIMH
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212365163"
Received: from 69-165-154-85.dsl.teksavvy.com (HELO pastel.home)
	([69.165.154.85])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	12 Jan 2013 11:12:24 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 42FDA592A5; Sat, 12 Jan 2013 11:12:24 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Bastien <bzg@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Message-ID: <jwv6232wfcu.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN> <87hamm8qze.fsf@HIDDEN>
	<jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN> <87liby7a57.fsf@HIDDEN>
Date: Sat, 12 Jan 2013 11:12:24 -0500
In-Reply-To: <87liby7a57.fsf@HIDDEN> (Bastien's message of "Sat, 12 Jan
	2013 15:23:32 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

> In that case, isn't it enough to call (package-initialize) before
> any Org configuration?

Here's the scenario:

start Emacs
use Org
use package.el to install a newer version of Org


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 14:23:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 09:23:56 2013
Received: from localhost ([127.0.0.1]:56464 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu203-0007kt-DH
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 09:23:56 -0500
Received: from mail-wg0-f41.google.com ([74.125.82.41]:37197)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bastienguerry@HIDDEN>) id 1Tu201-0007kh-KG
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 09:23:54 -0500
Received: by mail-wg0-f41.google.com with SMTP id ds1so369986wgb.2
	for <10125 <at> debbugs.gnu.org>; Sat, 12 Jan 2013 06:23:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:sender:from:to:cc:subject:in-reply-to:references
	:user-agent:date:message-id:mime-version:content-type;
	bh=jXMd79yhHJldXWq3htUx3xVCMMhK80D0cSwrzQuOGDc=;
	b=AYZqQ1a6admt2iKozEU63Z80MBHhUoS4OzrGLzhTnRuY8SMTzFHcNYhFC0CO8WuFQ9
	7HWCMGttY/+dnXdLJpEJ9H7WU7Tg7beEwpOoLx6m/7H6O9HUv68w1YoM/68qtIqkm4OZ
	EC58QwdLgDoGtcHKnSleeP8OasnkOqoqWXuWpVTr6H+GVBapiS/hVUVjTr+alqX4Zy5p
	UeYZ48YYgZmoADn3AP24eUl0ih5gICnn0kSfjJ5bMIg32gkkfH5x/7Do9stjkudJaLtj
	nnOt3XhPMipeBXrEeK89io+CWoOMlYJDp7rxeCg8UXqohtU6Jj58N/ZJ72iVmILRZG+Q
	apAw==
X-Received: by 10.180.102.170 with SMTP id fp10mr4125809wib.13.1358000613856; 
	Sat, 12 Jan 2013 06:23:33 -0800 (PST)
Received: from bzg.localdomain (mar75-2-81-56-68-112.fbx.proxad.net.
	[81.56.68.112])
	by mx.google.com with ESMTPS id ex6sm4221811wid.3.2013.01.12.06.23.32
	(version=TLSv1.1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Sat, 12 Jan 2013 06:23:32 -0800 (PST)
Received: by bzg.localdomain (Postfix, from userid 1000)
	id 15FCB1C20555; Sat, 12 Jan 2013 15:23:32 +0100 (CET)
From: Bastien <bzg@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-Reply-To: <jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Sat, 12 Jan 2013 09:03:44 -0500")
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN> <87hamm8qze.fsf@HIDDEN>
	<jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN>
User-Agent: Gnus/5.130006 (Ma Gnus v0.6) Emacs/24.3.50 (gnu/linux)
Date: Sat, 12 Jan 2013 15:23:32 +0100
Message-ID: <87liby7a57.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Stefan Monnier <monnier@HIDDEN> writes:

> It's just an experiment (AFAIK).

Okay.

>>> "Check whether a required feature has been shadowed by changing
>>> `load-path' after it has been loaded and reload that feature from
>>> current load-path in this case."
>> I don't understand why we need this.
>
> For the case where Org is installed via package.el rather than by
> manually downloading and following some installation instructions.

In that case, isn't it enough to call (package-initialize) before
any Org configuration?

-- 
 Bastien




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 14:04:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 09:04:06 2013
Received: from localhost ([127.0.0.1]:56447 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu1gr-0007Ij-Gt
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 09:04:05 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:40103)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Tu1gp-0007IE-Ce
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 09:04:03 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09FpZpV/2dsb2JhbABEgXuyFoEIghUBAQQBViMFCws0EhQYDSSIHAW6CZBEA4hCmnGBWIMH
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212361141"
Received: from 69-165-154-85.dsl.teksavvy.com (HELO pastel.home)
	([69.165.154.85])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	12 Jan 2013 09:03:44 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 8E025592A5; Sat, 12 Jan 2013 09:03:44 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Bastien <bzg@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Message-ID: <jwv8v7yy0bv.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN> <87hamm8qze.fsf@HIDDEN>
Date: Sat, 12 Jan 2013 09:03:44 -0500
In-Reply-To: <87hamm8qze.fsf@HIDDEN> (Bastien's message of "Sat, 12 Jan
	2013 14:34:29 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.5 (/)

>>>> Yes, this subroutine is never directly called from C, so placing an
>>>> advice should work just fine.
> I thought coding conventions prevented advising primitives?

Nothing prevents advising primitive functions (advising special forms
is another matter altogether).  But primitive functions can be called
from C directly (rather than via looking up the symbols' function cell)
in which case the advice will be ignored.

> I does not look clean to advise `require' here, just for Org.

It's just an experiment (AFAIK).

>> "Check whether a required feature has been shadowed by changing
>> `load-path' after it has been loaded and reload that feature from
>> current load-path in this case."
> I don't understand why we need this.

For the case where Org is installed via package.el rather than by
manually downloading and following some installation instructions.

> For package manager, a slightly more general version of the above (not
> conditionalized on the feature starting with "org" or "ob") could be
> used around the package compilation.  I haven't yet tried this, though.

Maybe the better way to do it is for package.el to compare the set of
files of the new package, with the set of currently loaded `features'
and unload the intersection.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 13:55:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 08:55:58 2013
Received: from localhost ([127.0.0.1]:56443 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu1Yz-00076V-Vs
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:55:58 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:55191)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1Tu1Yw-00076H-Ti
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:55:55 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MGI00L00MIIUC00@HIDDEN> for
	10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 15:55:31 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MGI00L1HMOHNJ60@HIDDEN>;
	Sat, 12 Jan 2013 15:55:30 +0200 (IST)
Date: Sat, 12 Jan 2013 15:55:54 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-reply-to: <jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83wqvisdxx.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
	<83ip72u89o.fsf@HIDDEN> <87ehhqn1md.fsf@HIDDEN>
	<8338y6txjh.fsf@HIDDEN> <jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 10125
Cc: Stromeko@HIDDEN, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.2 (-)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Achim Gratz <Stromeko@HIDDEN>,  10125 <at> debbugs.gnu.org
> Date: Sat, 12 Jan 2013 08:28:29 -0500
> 
> > IOW, do you expect the byte-compile instances to be different in any
> > way from a fresh Emacs session invoked from the shell as "emacs -Q"?
> 
> Yes, because the current Emacs may be a different executable than the
> one the shell would run in response to "emacs -Q".

And if we make sure the same executable is run (easy on Windows)?  Are
there any other differences?




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 13:34:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 08:34:53 2013
Received: from localhost ([127.0.0.1]:56423 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu1Ea-0006aP-Vq
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:34:53 -0500
Received: from mail-wg0-f46.google.com ([74.125.82.46]:56458)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bastienguerry@HIDDEN>) id 1Tu1EX-0006aC-Nr
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:34:51 -0500
Received: by mail-wg0-f46.google.com with SMTP id dr13so1243395wgb.25
	for <10125 <at> debbugs.gnu.org>; Sat, 12 Jan 2013 05:34:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:sender:from:to:cc:subject:in-reply-to:references
	:user-agent:date:message-id:mime-version:content-type;
	bh=YSJYsbsGSwDkylEYkdfZ9Xdgw0AykOVi7EOXs4cAAcs=;
	b=LSos24J9fxZN6r38xYMSL9sT+i6KX5Ic+CzHDk7zDXQjvlU+ACJ3BwWiMqeCSS7RD0
	6t6raGrQ+NdPbwqFAVwfbNiWAzK7hQc66WIfFYeAYXXCuHyyHZMKFN3r868+8oGAbXyV
	9V3S5eEdIrZdSX/RDvRO1zjoi9zTjmQQTeAuUl7NZbC6XlyGAKFn5YC+CG2dx15BEPI/
	kW849eLt5s98J4W5S7PjmCu8wRKgrg5kGkn9mfKK3Hw7tXTbt6VHdqekkAafFQWFFDaA
	pa9Lim1pqBSkMJS0wQAN0SSfoomMMqylYKztcsFRejk1fv9jSTj78tZbqOHcpBUIkclX
	SzwQ==
X-Received: by 10.194.82.168 with SMTP id j8mr126330722wjy.15.1357997671552;
	Sat, 12 Jan 2013 05:34:31 -0800 (PST)
Received: from bzg.localdomain (mar75-2-81-56-68-112.fbx.proxad.net.
	[81.56.68.112])
	by mx.google.com with ESMTPS id bw9sm3615059wib.5.2013.01.12.05.34.30
	(version=TLSv1.1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Sat, 12 Jan 2013 05:34:30 -0800 (PST)
Received: by bzg.localdomain (Postfix, from userid 1000)
	id 113371C20555; Sat, 12 Jan 2013 14:34:29 +0100 (CET)
From: Bastien <bzg@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-Reply-To: <87ip72n1v7.fsf@HIDDEN> (Achim Gratz's message of "Sat,
	12 Jan 2013 11:15:40 +0100")
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
	<87ip72n1v7.fsf@HIDDEN>
User-Agent: Gnus/5.130006 (Ma Gnus v0.6) Emacs/24.3.50 (gnu/linux)
Date: Sat, 12 Jan 2013 14:34:29 +0100
Message-ID: <87hamm8qze.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Achim Gratz <Stromeko@HIDDEN> writes:

> Achim Gratz writes:
>> Stefan Monnier writes:
>>> Yes, this subroutine is never directly called from C, so placing an
>>> advice should work just fine.

I thought coding conventions prevented advising primitives?
I does not look clean to advise `require' here, just for Org.

>   "Check whether a required feature has been shadowed by changing
> `load-path' after it has been loaded and reload that feature from
> current load-path in this case."

I don't understand why we need this.  

This is at best a workaround to fix dirty installations.

I updated Org's installation process yesterday:

  http://orgmode.org/org.html#Installation

I made it clear that the user, if she wants to install Org on top of
the pre-bundled version, must choose between on of the three methods.
For each method, I explain how to set up the load-path (if needed) and
org.el will load the correct org-loaddefs.el, resetting autoloads
correctly.

In org.el, no Org package is required before org-loaddefs.el is loaded.

> This takes care of a situation when Org is activated after some parts of
> it have already been loaded (maybe via autoload) and the load-path has
> been changed inbetween.

I don't see why this should happen.  Setting the correct load-paths is
the first thing user should do in their .emacs.el.

-- 
 Bastien




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 13:28:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 08:28:55 2013
Received: from localhost ([127.0.0.1]:56419 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu18k-0006Qv-IP
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:28:52 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:36018)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Tu18i-0006Qi-G6
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 08:28:49 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09FpZpV/2dsb2JhbABEgXuyFoEIghUBAQQBViMFCws0EhQYDSSIHAW6CZBEA4hCmnGBWIMH
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212360191"
Received: from 69-165-154-85.dsl.teksavvy.com (HELO pastel.home)
	([69.165.154.85])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	12 Jan 2013 08:28:30 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 1B3B7592A5; Sat, 12 Jan 2013 08:28:29 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Message-ID: <jwvehhqy1k8.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
	<87ehhqn1md.fsf@HIDDEN> <8338y6txjh.fsf@HIDDEN>
Date: Sat, 12 Jan 2013 08:28:29 -0500
In-Reply-To: <8338y6txjh.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 12 Jan
	2013 14:07:14 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

> IOW, do you expect the byte-compile instances to be different in any
> way from a fresh Emacs session invoked from the shell as "emacs -Q"?

Yes, because the current Emacs may be a different executable than the
one the shell would run in response to "emacs -Q".


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 12:07:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 07:07:20 2013
Received: from localhost ([127.0.0.1]:56375 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ttzrr-0003do-S2
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 07:07:20 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:48982)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1Ttzrp-0003dW-9c
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 07:07:18 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
	a-mtaout23.012.net.il (HyperSendmail v2007.08) id
	<0MGI00H00H1E3200@HIDDEN> for
	10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 14:06:50 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout23.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MGI00GG5HNEVV90@HIDDEN>;
	Sat, 12 Jan 2013 14:06:50 +0200 (IST)
Date: Sat, 12 Jan 2013 14:07:14 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-reply-to: <87ehhqn1md.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Achim Gratz <Stromeko@HIDDEN>
Message-id: <8338y6txjh.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
	<83ip72u89o.fsf@HIDDEN> <87ehhqn1md.fsf@HIDDEN>
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.2 (-)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Sat, 12 Jan 2013 11:20:58 +0100
> 
> Eli Zaretskii writes:
> >> Could be: depends on the precise semantics of spawn, which I don't know.
> >
> > I'm barely following this thread, so please tell what semantics do you
> > need, and I will then try figuring out whether spawn does what you
> > need.
> 
> The idea IIUC is to fork/spawn Emacs after it has initialized to be able
> to use a "pristine" instance to spawn off again for byte compilation.
> 
> emacs-pristine +--- emacs-user
>                |
>                +--- emacs-bytecompile-1
>                |
>                +--- emacs-bytecompile-2
>                |
>                +--- emacs-bytecompile-3

How is this different from invoking emacs-bytecompile-N instances in
parallel to invoking emacs-pristine?  IOW, do you expect the
byte-compile instances to be different in any way from a fresh Emacs
session invoked from the shell as "emacs -Q"?




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Jan 2013 11:27:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 06:27:14 2013
Received: from localhost ([127.0.0.1]:56326 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtzF4-0002Z3-LK
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:27:14 -0500
Received: from eggs.gnu.org ([208.118.235.92]:57061)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtzF2-0002Ys-UO
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:27:13 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtzEh-0005Xh-3E
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:26:55 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:33678)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtzEg-0005XW-W5
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:26:51 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40173)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtzEX-0005Ta-55
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 06:26:50 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtzER-0005V2-6z
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 06:26:40 -0500
Received: from plane.gmane.org ([80.91.229.3]:33719)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtyDB-0007vJ-Uk
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 05:21:14 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtyDM-0004gb-PZ
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 11:21:24 +0100
Received: from pd9eb289d.dip.t-dialin.net ([217.235.40.157])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 11:21:24 +0100
Received: from Stromeko by pd9eb289d.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 11:21:24 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sat, 12 Jan 2013 11:20:58 +0100
Organization: Linux Private Site
Lines: 25
Message-ID: <87ehhqn1md.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN> <83ip72u89o.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb289d.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.91 (gnu/linux)
Cancel-Lock: sha1:5aEaLVBoSd8tkywfZdTmXsk5qac=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Eli Zaretskii writes:
>> Could be: depends on the precise semantics of spawn, which I don't know.
>
> I'm barely following this thread, so please tell what semantics do you
> need, and I will then try figuring out whether spawn does what you
> need.

The idea IIUC is to fork/spawn Emacs after it has initialized to be able
to use a "pristine" instance to spawn off again for byte compilation.

emacs-pristine +--- emacs-user
               |
               +--- emacs-bytecompile-1
               |
               +--- emacs-bytecompile-2
               |
               +--- emacs-bytecompile-3

Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf Blofeld:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Jan 2013 11:08:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 06:08:47 2013
Received: from localhost ([127.0.0.1]:56315 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtyxD-00025r-FU
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:08:47 -0500
Received: from eggs.gnu.org ([208.118.235.92]:52909)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtyxB-00025f-VO
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:08:46 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ttywl-0000mC-KZ
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:08:28 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:53499)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ttywl-0000m2-HJ
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 06:08:19 -0500
Received: from eggs.gnu.org ([208.118.235.92]:35998)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ttywg-0007nr-TJ
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 06:08:19 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ttywa-0000kl-66
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 06:08:14 -0500
Received: from plane.gmane.org ([80.91.229.3]:38756)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tty8A-00076Y-DL
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 05:16:02 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tty8N-0001CI-9u
	for bug-gnu-emacs@HIDDEN; Sat, 12 Jan 2013 11:16:15 +0100
Received: from pd9eb289d.dip.t-dialin.net ([217.235.40.157])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 11:16:15 +0100
Received: from Stromeko by pd9eb289d.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Sat, 12 Jan 2013 11:16:15 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Sat, 12 Jan 2013 11:15:40 +0100
Organization: Linux Private Site
Lines: 57
Message-ID: <87ip72n1v7.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf__44551.6247455545$1357934081$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb289d.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.91 (gnu/linux)
Cancel-Lock: sha1:dKWvanI+OKnO08gvNkgu/R1axBs=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Achim Gratz writes:
> Stefan Monnier writes:
>> Yes, this subroutine is never directly called from C, so placing an
>> advice should work just fine.
>
> OK, I'll give it a try.

Here's what I've come up with:

--8<---------------cut here---------------start------------->8---
;; some parts of Org might already have been used from a different
;; place, try to reload these parts from the current load-path
(defadvice require (before org-require-reload-when-shadowed
			   (feature &optional filename noerror)
			   activate compile preactivate)
  "Check whether a required feature has been shadowed by changing
`load-path' after it has been loaded and reload that feature from
current load-path in this case."
  (when (featurep feature)
    (let ((feature-name (or filename (symbol-name feature))))
      (when (string-match "^\\(org\\|ob\\)[.-]" feature-name)
	(let ((feature-lib  (file-name-directory (or (locate-library feature-name) "")))
	      (feature-dir  (file-name-directory (feature-file feature))))
	  ;(message "require-reload-when shadowed %s\n\t%s\n\t%s" feature-name feature-lib feature-dir)
	  (when (not (string= feature-lib feature-dir))
	    (message "Reloading %s" feature-name)
	    (unload-feature feature t)))))))
(require 'org-macs)
(require 'org-compat)
(require 'org-entities)
(require 'org-faces)
(require 'org-list)
(require 'org-pcomplete)
(require 'org-src)
(require 'org-footnote)
;; babel
(require 'ob)
(eval-and-compile (ad-unadvise 'require))
--8<---------------cut here---------------end--------------->8---

This takes care of a situation when Org is activated after some parts of
it have already been loaded (maybe via autoload) and the load-path has
been changed inbetween.  This uses unload-feature although it would
probably work to just (setq features (delq feature features)).

For package manager, a slightly more general version of the above (not
conditionalized on the feature starting with "org" or "ob") could be
used around the package compilation.  I haven't yet tried this, though.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Waldorf Blofeld:
http://Synth.Stromeko.net/Downloads.html#BlofeldUserWavetables





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 12 Jan 2013 08:15:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 03:15:33 2013
Received: from localhost ([127.0.0.1]:56189 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtwFY-0006Mr-Mf
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 03:15:32 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:65201)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TtwFV-0006MO-TF
	for 10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 03:15:31 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
	a-mtaout23.012.net.il (HyperSendmail v2007.08) id
	<0MGI00G006E92R00@HIDDEN> for
	10125 <at> debbugs.gnu.org; Sat, 12 Jan 2013 10:15:09 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout23.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MGI00GTX6X71K50@HIDDEN>;
	Sat, 12 Jan 2013 10:15:08 +0200 (IST)
Date: Sat, 12 Jan 2013 10:15:31 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
In-reply-to: <jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83ip72u89o.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: QUOTED-PRINTABLE
X-012-Sender: halo1@HIDDEN
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
	<jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Date:
   Fri, 11 Jan 2013 17:52:33 -0500 > Cc: 10125 <at> debbugs.gnu.org > > >>>> I guess
    we could fork Emacs early on and keep this second process > >>>> around as
    a "process from which to generate new clean slates". > >>> I've been thinking
    about something like this for a while… if it worked > >>> at least as well
    as starting a new Emacs instance on all platforms, I'd > >>> favor this approach.
    > >> IIUC "fork" is not really an option for w32. > > For the intended application
    spawn should work as well? > > Could be: depends on the precise semantics
    of spawn, which I don't know. [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.175 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4942]
X-Debbugs-Envelope-To: 10125
Cc: Stromeko@HIDDEN, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.7 (/)

> From: Stefan Monnier <monnier@HIDDEN>
> Date: Fri, 11 Jan 2013 17:52:33 -0500
> Cc: 10125 <at> debbugs.gnu.org
>=20
> >>>> I guess we could fork Emacs early on and keep this second proc=
ess
> >>>> around as a "process from which to generate new clean slates".
> >>> I've been thinking about something like this for a while=E2=
=80=A6 if it worked
> >>> at least as well as starting a new Emacs instance on all platfo=
rms, I'd
> >>> favor this approach.
> >> IIUC "fork" is not really an option for w32.
> > For the intended application spawn should work as well?
>=20
> Could be: depends on the precise semantics of spawn, which I don't =
know.

I'm barely following this thread, so please tell what semantics do yo=
u
need, and I will then try figuring out whether spawn does what you
need.





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 11 Jan 2013 22:52:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 11 17:52:51 2013
Received: from localhost ([127.0.0.1]:55869 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtnT1-0000Zo-6r
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 17:52:51 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:38231)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TtnSz-0000Zb-1S
	for 10125 <at> debbugs.gnu.org; Fri, 11 Jan 2013 17:52:49 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtsGAG6Zu09MCpYP/2dsb2JhbABEgXuDMq5kgQiCFQEBBAEjMyMQCw4MAhgOAgIUGA0kiBwFpw6Se4EmjgqBFAOIQppxgViDBw
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212334592"
Received: from 76-10-150-15.dsl.teksavvy.com (HELO pastel.home)
	([76.10.150.15])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	11 Jan 2013 17:52:34 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id D372D5943D; Fri, 11 Jan 2013 17:52:33 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Message-ID: <jwvlibz2v6e.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
	<87bocvcx9f.fsf@HIDDEN>
Date: Fri, 11 Jan 2013 17:52:33 -0500
In-Reply-To: <87bocvcx9f.fsf@HIDDEN> (Achim Gratz's message of "Fri,
	11 Jan 2013 20:53:00 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

>>>> I guess we could fork Emacs early on and keep this second process
>>>> around as a "process from which to generate new clean slates".
>>> I've been thinking about something like this for a while=E2=80=A6 if it=
 worked
>>> at least as well as starting a new Emacs instance on all platforms, I'd
>>> favor this approach.
>> IIUC "fork" is not really an option for w32.
> For the intended application spawn should work as well?

Could be: depends on the precise semantics of spawn, which I don't know.

>> Along the same lines, we could try to use unload-feature.
> I thought this was potentially dangerous, but reading the docstring
> again maybe not.  Let me try that as well.

It's fundamentally tricky just in the same way as your proposed
"namespace cleanup": if you undefine a function that's still registered
on some hook, process filter, ... you may get subsequent errors, some of
which may render Emacs completely unusable.
So it's risky to call unload-feature on a random package, but it's not
too hard for a package to make sure it survives unload-feature.
Tho currently, there are some significant shortcomings (IIRC there are
cases where the package's autoloads aren't re-instated, for example).


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Jan 2013 19:53:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 11 14:53:48 2013
Received: from localhost ([127.0.0.1]:55832 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ttkfj-0004pF-Fn
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 14:53:48 -0500
Received: from eggs.gnu.org ([208.118.235.92]:55723)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ttkfh-0004p4-Hj
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 14:53:46 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfN-0005QE-Q8
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 14:53:32 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:33938)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfN-0005Q7-FP
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 14:53:25 -0500
Received: from eggs.gnu.org ([208.118.235.92]:38830)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfJ-0002kL-NO
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 14:53:25 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfF-0005PO-Tr
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 14:53:21 -0500
Received: from plane.gmane.org ([80.91.229.3]:60921)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfF-0005P9-NB
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 14:53:17 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1TtkfS-0000rq-5I
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 20:53:30 +0100
Received: from pd9eb573f.dip.t-dialin.net ([217.235.87.63])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Fri, 11 Jan 2013 20:53:30 +0100
Received: from Stromeko by pd9eb573f.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Fri, 11 Jan 2013 20:53:30 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Fri, 11 Jan 2013 20:53:00 +0100
Organization: Linux Private Site
Lines: 40
Message-ID: <87bocvcx9f.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
	<jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb573f.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.91 (gnu/linux)
Cancel-Lock: sha1:gbjkxXSLIVjI3i6tH12Z+sXfP/E=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -5.5 (-----)

Stefan Monnier writes:
>>> I guess we could fork Emacs early on and keep this second process
>>> around as a "process from which to generate new clean slates".
>> I've been thinking about something like this for a while… if it worked
>> at least as well as starting a new Emacs instance on all platforms, I'd
>> favor this approach.
>
> IIUC "fork" is not really an option for w32.

For the intended application spawn should work as well?

> Yes, this subroutine is never directly called from C, so placing an
> advice should work just fine.

OK, I'll give it a try.

>> As long as the package is properly namespaced, why not allow for
>> removing all definitions pertaining to that entire namespace (features,
>> autoloads, definitions, …)?
>
> We could try that, as well, but it would only work for those packages
> that are "properly namespaced" (and there's no way to detect that
> AFAIK).

True, but a package might indicate if it is "one of those" and get the
appropriate treatment from package manager.

> Along the same lines, we could try to use unload-feature.

I thought this was potentially dangerous, but reading the docstring
again maybe not.  Let me try that as well.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf Q+, Q and microQ:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 11 Jan 2013 16:56:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 11 11:56:24 2013
Received: from localhost ([127.0.0.1]:55719 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tthu4-0000Te-2p
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:56:24 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:9561)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Tthu2-0000TS-2W
	for 10125 <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:56:22 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtsGAG6Zu09MCpYP/2dsb2JhbABEgXuDMq5kgQiCFQEBBAEjMyMFCwsODAIYDgICFBgNJC6HbgWnDpJ7gSaOCoEUA4hCmnGBWIMH
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212309278"
Received: from 76-10-150-15.dsl.teksavvy.com (HELO pastel.home)
	([76.10.150.15])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	11 Jan 2013 11:56:08 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 1A1BF59441; Fri, 11 Jan 2013 11:56:07 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Message-ID: <jwvvcb34qjg.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	<87wqvjd7qa.fsf@HIDDEN>
Date: Fri, 11 Jan 2013 11:56:07 -0500
In-Reply-To: <87wqvjd7qa.fsf@HIDDEN> (Achim Gratz's message of "Fri,
	11 Jan 2013 17:06:53 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

>> I guess we could fork Emacs early on and keep this second process
>> around as a "process from which to generate new clean slates".
> I've been thinking about something like this for a while=E2=80=A6 if it w=
orked
> at least as well as starting a new Emacs instance on all platforms, I'd
> favor this approach.

IIUC "fork" is not really an option for w32.

>> I suggested a quick&dirty solution:
>>> > E.g. we could add to bytecomp.el the ability to force `require' to
>>> > reload a package if it's not already loaded from the file that
>>> > locate-library returns.
>> I still think it's not a bad option.
> Would an advice work in this situation (given that require is a
> primitive)?

Yes, this subroutine is never directly called from C, so placing an
advice should work just fine.

> If yes, I'd like to give it a try over the weekend.  If not, I don't
> really see why require, more specifically the part that checks
> features needs to be a primitive, so maybe it could be moved partly
> to elisp.

AFAICT the only part of `require' which can't be written in Elisp right
now is the part that handles Vautoload_queue because that variable is
not exposed to Elisp (IIRC this variable is used to undo the effects of
a partially loaded file when the load bumps into an error midway
through; FWIW I'm not convinced this feature works reliably nowadays).

>> I don't see why that would introduce a difficulty.
> As long as the package is properly namespaced, why not allow for
> removing all definitions pertaining to that entire namespace (features,
> autoloads, definitions, =E2=80=A6)?

We could try that, as well, but it would only work for those packages
that are "properly namespaced" (and there's no way to detect that
AFAIK).
Along the same lines, we could try to use unload-feature.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Jan 2013 16:07:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 11 11:07:46 2013
Received: from localhost ([127.0.0.1]:55691 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tth90-0007kP-84
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:07:46 -0500
Received: from eggs.gnu.org ([208.118.235.92]:34956)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8w-0007k9-Mq
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:07:43 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8e-0001qS-LV
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:07:29 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-101.9 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE,
	RP_MATCHES_RCVD,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:56509)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8e-0001qO-IB
	for submit <at> debbugs.gnu.org; Fri, 11 Jan 2013 11:07:24 -0500
Received: from eggs.gnu.org ([208.118.235.92]:46263)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8b-0007lB-0n
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 11:07:24 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8U-0001oP-3d
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 11:07:20 -0500
Received: from plane.gmane.org ([80.91.229.3]:57766)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8T-0001oI-T1
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 11:07:14 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
	(envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Tth8g-0004fC-L3
	for bug-gnu-emacs@HIDDEN; Fri, 11 Jan 2013 17:07:26 +0100
Received: from pd9eb4cfd.dip.t-dialin.net ([217.235.76.253])
	by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
	id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Fri, 11 Jan 2013 17:07:26 +0100
Received: from Stromeko by pd9eb4cfd.dip.t-dialin.net with local (Gmexim 0.1
	(Debian)) id 1AlnuQ-0007hv-00
	for <bug-gnu-emacs@HIDDEN>; Fri, 11 Jan 2013 17:07:26 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
Date: Fri, 11 Jan 2013 17:06:53 +0100
Organization: Linux Private Site
Lines: 54
Message-ID: <87wqvjd7qa.fsf@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: pd9eb4cfd.dip.t-dialin.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.91 (gnu/linux)
Cancel-Lock: sha1:xCGL53cx4/yHYHMGISZG66/9vRo=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

Stefan Monnier writes:
>    I guess we could fork Emacs early on and keep this second process
>    around as a "process from which to generate new clean slates".

I've been thinking about something like this for a while… if it worked
at least as well as starting a new Emacs instance on all platforms, I'd
favor this approach.

> - outdated .elc file taking precedence over the new .el file can do
>   the same.

Yes, but you get a warning and can already arrange for this (by binding
the appropriate variables) to be no problem in practise.  See the way
org-reload works in current master (of the Org repo).

> - bytecompiling a file affects the running session by side-effects such
>   as requiring packages.

If that problem was finally solved that would be very welcome.

> I suggested a quick&dirty solution:
>> > E.g. we could add to bytecomp.el the ability to force `require' to
>> > reload a package if it's not already loaded from the file that
>> > locate-library returns.
>
> I still think it's not a bad option.

Would an advice work in this situation (given that require is a
primitive)?  If yes, I'd like to give it a try over the weekend.  If
not, I don't really see why require, more specifically the part that
checks features needs to be a primitive, so maybe it could be moved
partly to elisp.

> Of course, we'd still get trouble when the loading is not performed via
> `require' but via autoload (maybe we could try and attack this problem
> by allowing `autoload' to override an already existing definition, but
> that could be delicate).

That I'd like to split off from the discussion about require.

> I don't see why that would introduce a difficulty.

As long as the package is properly namespaced, why not allow for
removing all definitions pertaining to that entire namespace (features,
autoloads, definitions, …)?


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptation for Waldorf Blofeld V1.15B11:
http://Synth.Stromeko.net/Downloads.html#WaldorfSDada





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 11 Jan 2013 02:46:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 10 21:46:07 2013
Received: from localhost ([127.0.0.1]:54837 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtUdD-0004i7-38
	for submit <at> debbugs.gnu.org; Thu, 10 Jan 2013 21:46:07 -0500
Received: from mail-pb0-f50.google.com ([209.85.160.50]:38903)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <kjambunathan@HIDDEN>) id 1TtUdA-0004ha-Ld
	for 10125 <at> debbugs.gnu.org; Thu, 10 Jan 2013 21:46:05 -0500
Received: by mail-pb0-f50.google.com with SMTP id wz7so670427pbc.23
	for <10125 <at> debbugs.gnu.org>; Thu, 10 Jan 2013 18:45:54 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:from:to:cc:subject:references:date:in-reply-to
	:message-id:user-agent:mime-version:content-type;
	bh=aFLY8SWKCAXzSvxXrwMCATnqGxL5iTMmYLu7kU9ySus=;
	b=SQQlzwzyjkI1IQOmisy7qNQCKvYgzu3VT5it+btKKHc7AY7DFKNc4atPWd+ArCTv3e
	3XC4IHj4OSbBSgOet6dG6j8yLYoxpCAUs78yKY1nJFo8acDvDWIsSPI9VdX/kNS7MuXr
	gh0KThAmd2eGsh1gmQghzrknnQE3GHjZJcvi//NtV8tIV9mkPLGBGLRA4FLgMvzDiROE
	oz2YRgOf1W1yg7FQzkjvIYORzIFOHF/GkSqO4qE7BtwcEVYJ3fiGSPUyC6LfcRyh8mLk
	jH3APJ28xtRIom+R65kdAm196E8LRHKU/B4vjRY6kzg8aM9lHMAklztcwIqsbtlU1iI7
	xnEg==
X-Received: by 10.66.84.3 with SMTP id u3mr202528468pay.51.1357872354252;
	Thu, 10 Jan 2013 18:45:54 -0800 (PST)
Received: from debian-6.05 ([115.242.216.199])
	by mx.google.com with ESMTPS id ty4sm1851151pbc.57.2013.01.10.18.45.50
	(version=TLSv1.1 cipher=RC4-SHA bits=128/128);
	Thu, 10 Jan 2013 18:45:53 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: RFE: require and load-path-shadowing
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
	<jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
Date: Fri, 11 Jan 2013 08:15:38 +0530
In-Reply-To: <jwvvcb47bs0.fsf-monnier+emacs__21035.4545656175$1357869514$gmane$org@HIDDEN>
	(Stefan Monnier's message of "Thu, 10 Jan 2013 20:57:41 -0500")
Message-ID: <87wqvk5tf1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 10125
Cc: Glenn Morris <rgm@HIDDEN>, Achim Gratz <Stromeko@HIDDEN>,
	10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Stefan Monnier <monnier@HIDDEN> writes:

> - outdated .elc file taking precedence over the new .el file can do
>   the same.

I find this warning quite useful.

Consider this, all happening because of what is in .emacs.

1. Something in .emacs causes org-x to be loaded from Vanilla Emacs.

2. Load path changed to point to a git checkout.

3. User does something which loads org-y.  org-y comes from (2).  The
   chain of events ends up with requiring an org-x.  org-x WASN'T
   RE-LOADED because the symbol is provided.  Ofcourse, it is provided
   from the wrong place.

In case of (3), a warning that says "I refuse to have mutiple
personality disorder".   A warning during Emacs initing could be
missed.  So if there is a command line option to trigger an abrupt-end,
we could advise the user to enable it and say "You have got a problem in
your init file.  Not the Org-mode that is distributed."

This will serve to remove endless amount of confusion.

What I am saying, even if we couldn't solve the problem cleanly, a
simple warning that says "Something fishy" will greatly reduce the user
complaints in the Org list.

I am not sure how much of what I typed makes sense.  But I type
nevertheless, people read it or ignore it.
-- 




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 11 Jan 2013 01:57:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 10 20:57:54 2013
Received: from localhost ([127.0.0.1]:54802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TtTsX-0003bN-UR
	for submit <at> debbugs.gnu.org; Thu, 10 Jan 2013 20:57:54 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:41445)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TtTsW-0003b9-Ab
	for 10125 <at> debbugs.gnu.org; Thu, 10 Jan 2013 20:57:52 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09MCpYP/2dsb2JhbABEgXuyFoEIghUBAQQBViMFCwsOJhIUGA0kLoduBQu5fpBEA4hCjWiNCYFYgwc
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212270208"
Received: from 76-10-150-15.dsl.teksavvy.com (HELO pastel.home)
	([76.10.150.15])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	10 Jan 2013 20:57:42 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id D2F28592BE; Thu, 10 Jan 2013 20:57:41 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: RFE: require and load-path-shadowing
Message-ID: <jwvvcb47bs0.fsf-monnier+emacs@HIDDEN>
References: <87sj68eogm.fsf@HIDDEN> <mthamoy574.fsf@HIDDEN>
Date: Thu, 10 Jan 2013 20:57:41 -0500
In-Reply-To: <mthamoy574.fsf@HIDDEN> (Glenn Morris's message of
	"Thu, 10 Jan 2013 18:43:43 -0500")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 10125
Cc: Achim Gratz <Stromeko@HIDDEN>, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

>> There is currently a problem with package manager when a package is
>> installed from a package archive,that package is already installed
>> either in Emacs core or site-lisp, and when (parts of) said package have
>> already been loaded when ELPA tries to install: the byte-compiler will
>> use the already loaded definitions rather than the new ones from the
>> package to install.
> I guess this would be http://debbugs.gnu.org/cgi/bugreport.cgi?bug=10125

Indeed, and as I mentioned back then I think it's a general enough
problem that we should try and think up a good solution.

Currently, we have two proposals:

1- run a separate Emacs instance: this gives you a clean slate, and lets
   you compile in parallel, but runs into the difficulty of figuring out
   exactly which clean slate to use.
   I guess we could fork Emacs early on and keep this second process
   around as a "process from which to generate new clean slates".

2- improve bytecomp.el to try and better isolate the compiled file from
   the previously loaded packages.

I don't see a clear winner, but since I'm biased in favor of the second
(not sure why, to tell you the truth), I'll add a few points related to
it.  The current behavior of bytecomp.el leads to various related
problems:
- outdated but already loaded packages can lead to mis-compilation.
  for the bootstrap we try to workaround this with
  byte-compile-refresh-preloaded, tho it only takes care of some
  particular cases.
- outdated .elc file taking precedence over the new .el file can do
  the same.
- bytecompiling a file affects the running session by side-effects such
  as requiring packages.
- if a package calls `byte-compile' during its own compilation, this
  sub-compilation will tend to complain about undeclared variables
  because it doesn't know about the vars that have been defvar'd in the
  outer compilation.  That's one of the main reasons for cc-bytecomp's
  hideous gymnastics.

Maybe we should (similarly to the fork idea above) keep a "clean
obarray", and run byte-compilations in a fresh copy of this
clean obarray.

I suggested a quick&dirty solution:
> > E.g. we could add to bytecomp.el the ability to force `require' to
> > reload a package if it's not already loaded from the file that
> > locate-library returns.

I still think it's not a bad option.

Of course, we'd still get trouble when the loading is not performed via
`require' but via autoload (maybe we could try and attack this problem
by allowing `autoload' to override an already existing definition, but
that could be delicate).

> That will probably work fine most of the time, but what if a package is
> restructed so that the feature names are different? Or a feature is
> removed?

I don't see why that would introduce a difficulty.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 19:23:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 14:23:11 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RU1Mc-0000JY-HQ
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:23:11 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RU1Ma-0000JQ-Fq
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:23:09 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RU1Kz-0000w0-7X; Fri, 25 Nov 2011 14:21:29 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN> <87r50w47o3.fsf@HIDDEN>
	<jwvaa7kgsmm.fsf-monnier+emacs@HIDDEN>
	<4vcq8xbby.fsf@HIDDEN>
X-Spook: SAFE Al-Qaeda plutonium radar SRI virus mailbomb Plame
X-Ran: 8D#,46z0qJ!{#3);#etNsT*4.'CS<<cd6j=6}"N%rj/[%nNN!pRPpYf{hp&CErgY['Q_)a
X-Hue: cyan
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Fri, 25 Nov 2011 14:21:28 -0500
In-Reply-To: <4vcq8xbby.fsf@HIDDEN> (Glenn Morris's message of
	"Fri, 25 Nov 2011 14:15:45 -0500")
Message-ID: <k9ehwwm2iv.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, Chong Yidong <cyd@HIDDEN>, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Glenn Morris wrote:

> the package has defined. Though you would have to trust the package not
> to do anything nasty.

Of course, you already have to trust it since byte-compiling can run
arbitrary code.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 19:17:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 14:17:27 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RU1H4-0000B4-SR
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:17:27 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RU1H2-0000Ax-OM
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:17:25 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RU1FR-0000dZ-JK; Fri, 25 Nov 2011 14:15:45 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN> <87r50w47o3.fsf@HIDDEN>
	<jwvaa7kgsmm.fsf-monnier+emacs@HIDDEN>
X-Spook: plutonium Legion of Doom Albanian spies asset Project
X-Ran: J\6s,yE6zX7kztQ^,x$e{86m#u-LEYfsR4YdYxJ".fYAUv3/X;=h{fIr`pm;._|&3gAG3d
X-Hue: blue
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Fri, 25 Nov 2011 14:15:45 -0500
In-Reply-To: <jwvaa7kgsmm.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Fri, 25 Nov 2011 09:57:33 -0500")
Message-ID: <4vcq8xbby.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, Chong Yidong <cyd@HIDDEN>, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Stefan Monnier wrote:

> E.g. we could add to bytecomp.el the ability to force `require' to
> reload a package if it's not already loaded from the file that
> locate-library returns.

That will probably work fine most of the time, but what if a package is
restructed so that the feature names are different? Or a feature is
removed? Simply starting a fresh Emacs seems fine to me. Though there is
the issue of should it be a `-Q' one or not.

BTW, I was also thinking that rather than simply byte-recompiling,
package.el ought to check for a Makefile in the package directory, and
if it finds one, call make to build the package according to the rules
the package has defined. Though you would have to trust the package not
to do anything nasty.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 19:03:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 14:03:35 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RU13f-0008Iw-Ef
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:03:35 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RU13d-0008Ip-6f
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 14:03:34 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RU122-00088k-5q; Fri, 25 Nov 2011 14:01:54 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Chong Yidong <cyd@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN> <87r50w47o3.fsf@HIDDEN>
	<pr4nxsxdx7.fsf@HIDDEN>
X-Spook: BLU-114/B Albright halcon Noriega high security terrorism
X-Ran: @L(P;PymV7c=i7#IuWCQjBanj7SSWg^{(R[*'+\!~ukp5|jHL=~OqnTu'(76SA-2datkj6
X-Hue: magenta
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Fri, 25 Nov 2011 14:01:53 -0500
In-Reply-To: <pr4nxsxdx7.fsf@HIDDEN> (Glenn Morris's message of
	"Fri, 25 Nov 2011 13:19:48 -0500")
Message-ID: <gvipm881r2.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Glenn Morris wrote:

>> This uses the Emacs executable on the exec path, which might not be the
>> correct one.
>
> Yes; I wondered if (car command-line-args) was a reliable way to find
> the actual name of the running Emacs binary?

Turns out I was looking for invocation-directory and invocation-name.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 18:22:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 13:22:05 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RU0PU-0005pP-Ve
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 13:22:05 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RU0PT-0005p8-2V
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 13:22:03 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RU0Ns-0005V6-2r; Fri, 25 Nov 2011 13:20:24 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<83vcq88vwt.fsf@HIDDEN>
X-Spook: Osama BCCI nitrate Panama oil Noriega World Trade Center
X-Ran: -aiEyKf|jQa$U_8h-;G0YzRK=I3JRXz/l~*Tk$H\KdQE:m@>G@M4EWeR9nGn3vZ_RRu9})
X-Hue: red
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Fri, 25 Nov 2011 13:20:24 -0500
In-Reply-To: <83vcq88vwt.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 25 Nov
	2011 10:10:26 +0200")
Message-ID: <vgzkfkvzbr.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org, kjambunathan@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Eli Zaretskii wrote:

> I think package.el should test with featurep whether a version of a
> package is already loaded, and refuse to load it into a running
> session, or at least display a warning to that effect, suggesting to
> restart Emacs.

Yes, that might be better.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 18:21:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 13:21:29 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RU0Ov-0005oC-Od
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 13:21:29 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RU0Ou-0005o6-1y
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 13:21:28 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RU0NI-0005O1-BA; Fri, 25 Nov 2011 13:19:48 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Chong Yidong <cyd@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN> <87r50w47o3.fsf@HIDDEN>
X-Spook: CNCIS Mena Echelon Europol AIEWS NORAD Firewalls STARLAN
X-Ran: 6n^vgYx=cKQ}x5w{4D|"MmmpRy]7oUtv>{V"WJyvVPij5Cr3VL-2=+vcsa|8l<up^[kQJA
X-Hue: red
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Fri, 25 Nov 2011 13:19:48 -0500
In-Reply-To: <87r50w47o3.fsf@HIDDEN> (Chong Yidong's message of "Fri, 25 Nov
	2011 22:07:40 +0800")
Message-ID: <pr4nxsxdx7.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Chong Yidong wrote:

> This uses the Emacs executable on the exec path, which might not be the
> correct one.

Yes; I wondered if (car command-line-args) was a reliable way to find
the actual name of the running Emacs binary?




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 14:59:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 09:59:15 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTxFD-00019f-79
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 09:59:15 -0500
Received: from chene.dit.umontreal.ca ([132.204.246.20])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>) id 1RTxFB-00019Z-Rw
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 09:59:14 -0500
Received: from pastel.home (lechon.iro.umontreal.ca [132.204.27.242])
	by chene.dit.umontreal.ca (8.14.1/8.14.1) with ESMTP id pAPEvYH5003459; 
	Fri, 25 Nov 2011 09:57:34 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id F33C058D75; Fri, 25 Nov 2011 09:57:33 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Chong Yidong <cyd@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
Message-ID: <jwvaa7kgsmm.fsf-monnier+emacs@HIDDEN>
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN> <87r50w47o3.fsf@HIDDEN>
Date: Fri, 25 Nov 2011 09:57:33 -0500
In-Reply-To: <87r50w47o3.fsf@HIDDEN> (Chong Yidong's message of "Fri, 25 Nov
	2011 22:07:40 +0800")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV4052=0
X-NAI-Spam-Version: 2.2.0.9286 : core <4052> : streams <704705> : uri <1015408>
X-Spam-Score: -4.4 (----)
X-Debbugs-Envelope-To: 10125
Cc: Glenn Morris <rgm@HIDDEN>, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>, stelian.iancu@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.4 (----)

>>> fresh Emacs instance. There's no reason the "package manager" could not
>>> spawn a separate Emacs in batch-mode as a sub-job to do the compilation.
>> Very lightly tested version:
> This uses the Emacs executable on the exec path, which might not be the
> correct one.
> I'm wary of making such a fundamental change to package.el without first
> exploring possible package-specific work-arounds.

Yes, this should not a candidate for 24.1.

> Could problematic packages use an eval-when-compile form to forcibly
> load the correct version of the required file?

I think it's a sufficiently general problem that we might want to
provide some special support for a good solution (tho again, I doubt
there's something simple&safe enough to be a candidate for 24.1).

E.g. we could add to bytecomp.el the ability to force `require' to
reload a package if it's not already loaded from the file that
locate-library returns.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 14:09:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 09:09:30 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTwT3-0008OV-Fe
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 09:09:30 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1RTwT1-0008ON-Ej
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 09:09:28 -0500
Received: from bb121-6-203-164.singnet.com.sg ([121.6.203.164]:52888
	helo=furball)
	by fencepost.gnu.org with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.71) (envelope-from <cyd@HIDDEN>)
	id 1RTwRR-0004tp-1a; Fri, 25 Nov 2011 09:07:49 -0500
From: Chong Yidong <cyd@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN>
Date: Fri, 25 Nov 2011 22:07:40 +0800
In-Reply-To: <hffwhdqov3.fsf@HIDDEN> (Glenn Morris's message of
	"Thu, 24 Nov 2011 14:53:04 -0500")
Message-ID: <87r50w47o3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

Glenn Morris <rgm@HIDDEN> writes:

> Glenn Morris wrote:
>
>> fresh Emacs instance. There's no reason the "package manager" could not
>> spawn a separate Emacs in batch-mode as a sub-job to do the compilation.
>
> Very lightly tested version:

This uses the Emacs executable on the exec path, which might not be the
correct one.

I'm wary of making such a fundamental change to package.el without first
exploring possible package-specific work-arounds.  Could problematic
packages use an eval-when-compile form to forcibly load the correct
version of the required file?




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 12:34:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 07:34:54 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTuzW-00069C-Na
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 07:34:54 -0500
Received: from mail-ee0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <stelian.iancu@HIDDEN>) id 1RTuzV-000696-GF
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 07:34:54 -0500
Received: by eear51 with SMTP id r51so228764eea.3
	for <10125 <at> debbugs.gnu.org>; Fri, 25 Nov 2011 04:33:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type;
	bh=n1JxKrisLCoc4QsnvTTQaTQ1kE4pra3D2VDKM8vVwBw=;
	b=Q5yIPN/qSAQ/OH9cihVpOKsaCILi8/6cNSTPMPJLqP6eqvTqoctQGDPrn6TcWTMwkR
	VKTZBMz4Hd+6HMeEBgAQnXovj4XM6M5IHs3b5UTNTu3fO9a333hW0IMK+iuNPNHYcPkx
	DPz6H3hDFqhw7ozUuCyp1gyfuBWhkL1PqggDI=
Received: by 10.14.4.21 with SMTP id 21mr2051386eei.35.1322224396172; Fri, 25
	Nov 2011 04:33:16 -0800 (PST)
MIME-Version: 1.0
Received: by 10.213.20.17 with HTTP; Fri, 25 Nov 2011 04:32:55 -0800 (PST)
In-Reply-To: <81lir4anej.fsf@HIDDEN>
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
	<81lir4anej.fsf@HIDDEN>
From: Stelian Iancu <stelian.iancu@HIDDEN>
Date: Fri, 25 Nov 2011 13:32:55 +0100
Message-ID: <CAKvLAojUzYmrUF_64WXEbj9zmBjzZ4gn5cDYVqLTcik41PFJ7w@HIDDEN>
Subject: Re: bug#10125: 24.0.91; package.el (org): Macros in tar packages &
	order of byte compilation
To: Jambunathan K <kjambunathan@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

On Fri, Nov 25, 2011 at 04:31, Jambunathan K <kjambunathan@HIDDEN> wrote:
>
> Stelian
>
>> I am sorry to be asking a stupid question, but then, wouldn't restart
>> Emacs fix the issue and have the new compiled org files loaded? In my
>> case, that didn't seem to happen either (even though load-library
>> showed org-compat to be from ELPA).
>
> locate-library doesn't show what is *already* loaded. It will only shows
> what *will* be loaded.
>
> The most important thing during package compilation is this: Make sure
> there is no running instance of Org in any form. If this condition is
> not satisfied then to-be-installed files will be compiled with old
> definitions of macro. This is not what we want. We want the new files to
> be compiled with new macro definitions.
>
> Do things work for you when you start a *minimal* Emacs and *then* do
> M-x list-packages -> install? You don't have to apply Glenn's patch to
> get the desired behaviour (I am assuming here that you are probably not
> that comfortable working with patches).
>

I will try with a minimal Emacs first. You're right, I don't know my
way around patches that well :-). I am on OSX and I suppose I could
use something like homebrew for including the patch and building.

> Jambunathan K.
> --
>




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 12:17:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 07:17:11 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTuiN-0004zr-8M
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 07:17:11 -0500
Received: from mail-gx0-f172.google.com ([209.85.161.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTuiK-0004zj-ID
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 07:17:09 -0500
Received: by ggnp4 with SMTP id p4so3422220ggn.3
	for <10125 <at> debbugs.gnu.org>; Fri, 25 Nov 2011 04:15:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=from:to:cc:subject:references:date:in-reply-to:message-id
	:user-agent:mime-version:content-type;
	bh=lAtls9CDKmzFQqTtZGUcz6K+yImSlbeQlsphYRSLEKg=;
	b=QzNCwiviPHWmSXx3g0AQ3anim10asLCV70Pet0VL8Lnqubr6bqNGlAuqpu7JcRGcb8
	pLOoP1JIaH905JsRJGYn8dP5TR+e6xkhfawx440SqaCT2lsVw54h4XCCTERMbs96fWuh
	RZRVzSkvpjtUoQh6LOGMVemLJvj7/TR3zsBIY=
Received: by 10.50.88.135 with SMTP id bg7mr14642732igb.11.1322223331057;
	Fri, 25 Nov 2011 04:15:31 -0800 (PST)
Received: from JAMBU-NETBOOK ([115.241.34.208])
	by mx.google.com with ESMTPS id eb23sm1098046ibb.2.2011.11.25.04.15.25
	(version=TLSv1/SSLv3 cipher=OTHER);
	Fri, 25 Nov 2011 04:15:29 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<hffwhdqov3.fsf@HIDDEN>
Date: Fri, 25 Nov 2011 17:45:09 +0530
In-Reply-To: <hffwhdqov3.fsf@HIDDEN> (Glenn Morris's message of
	"Thu, 24 Nov 2011 14:53:04 -0500")
Message-ID: <8162i8csaa.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.91 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.8 (---)


Glenn

Glenn Morris <rgm@HIDDEN> writes:
> Glenn Morris wrote:
>
>> fresh Emacs instance. There's no reason the "package manager" could not
>> spawn a separate Emacs in batch-mode as a sub-job to do the
>> compilation.

I will let Stelian or any aggrieved future parties to test the patch. 

[...context switch...]

I am wondering whether a knob to "not compile" installed packages is a
good option in general. Can the autoloads be still generated even if the
files themselves are not compiled?

Jambunathan K.





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 08:12:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 25 03:12:05 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTqtB-0007RB-RM
	for submit <at> debbugs.gnu.org; Fri, 25 Nov 2011 03:12:05 -0500
Received: from mtaout21.012.net.il ([80.179.55.169])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <eliz@HIDDEN>) id 1RTqtA-0007R5-Rv
	for 10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 03:12:05 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
	a-mtaout21.012.net.il (HyperSendmail v2007.08) id
	<0LV700300IMK8P00@HIDDEN> for
	10125 <at> debbugs.gnu.org; Fri, 25 Nov 2011 10:10:26 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.228.50.247]) by a-mtaout21.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0LV7003OEIPB8O00@HIDDEN>;
	Fri, 25 Nov 2011 10:10:26 +0200 (IST)
Date: Fri, 25 Nov 2011 10:10:26 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
In-reply-to: <v062i9tk0d.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Glenn Morris <rgm@HIDDEN>
Message-id: <83vcq88vwt.fsf@HIDDEN>
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
X-Spam-Score: -2.0 (--)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org, kjambunathan@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.0 (--)

> From: Glenn Morris <rgm@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, 10125 <at> debbugs.gnu.org,  stelian.iancu@HIDDEN
> Date: Thu, 24 Nov 2011 14:09:38 -0500
> 
> I guess nobody ever expected the package manager to be used to load a
> different version of something that was already in Emacs.

Indeed.  Because doing this is asking for trouble: Emacs loads
packages in a certain order to avoid several subtle problems; doing
that in a different order defeats that.

I think package.el should test with featurep whether a version of a
package is already loaded, and refuse to load it into a running
session, or at least display a warning to that effect, suggesting to
restart Emacs.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 25 Nov 2011 03:33:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 22:33:13 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTmXJ-0000nl-9U
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 22:33:13 -0500
Received: from mail-iy0-f172.google.com ([209.85.210.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTmXG-0000nd-PQ
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 22:33:11 -0500
Received: by iaeo4 with SMTP id o4so3877218iae.3
	for <10125 <at> debbugs.gnu.org>; Thu, 24 Nov 2011 19:31:35 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=from:to:cc:subject:references:date:in-reply-to:message-id
	:user-agent:mime-version:content-type;
	bh=7dCe8ivdmiSVP/Ta0YgVCxSzIuGyhj5v8Z8qWkCxYDM=;
	b=yBShgoZWPqKcHEuqvNCuLYxrf1deRVaXE2SzjyCSQg4DmrwPk8/S88ckGx2chp+GgM
	kqNAnz80eOFKgEZhJPUABjpdgHEPY9wNVCjP/eOwswFf8IOuQzHCpRKJAtzHWZi9UqAI
	/j3QQT3b1h63Xq35qHGwBxK2UXosgTx0zW3sI=
Received: by 10.50.40.198 with SMTP id z6mr16331922igk.39.1322191895614;
	Thu, 24 Nov 2011 19:31:35 -0800 (PST)
Received: from JAMBU-NETBOOK ([115.184.102.160])
	by mx.google.com with ESMTPS id
	bu33sm95575726ibb.11.2011.11.24.19.31.31
	(version=TLSv1/SSLv3 cipher=OTHER);
	Thu, 24 Nov 2011 19:31:34 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: Stelian Iancu <stelian.iancu@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
Date: Fri, 25 Nov 2011 09:01:16 +0530
In-Reply-To: <CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
	(Stelian Iancu's message of "Thu, 24 Nov 2011 23:55:48 +0100")
Message-ID: <81lir4anej.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.91 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: 10125
Cc: 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.8 (---)


Stelian

> I am sorry to be asking a stupid question, but then, wouldn't restart
> Emacs fix the issue and have the new compiled org files loaded? In my
> case, that didn't seem to happen either (even though load-library
> showed org-compat to be from ELPA).

locate-library doesn't show what is *already* loaded. It will only shows
what *will* be loaded. 

The most important thing during package compilation is this: Make sure
there is no running instance of Org in any form. If this condition is
not satisfied then to-be-installed files will be compiled with old
definitions of macro. This is not what we want. We want the new files to
be compiled with new macro definitions.

Do things work for you when you start a *minimal* Emacs and *then* do
M-x list-packages -> install? You don't have to apply Glenn's patch to
get the desired behaviour (I am assuming here that you are probably not
that comfortable working with patches).

Jambunathan K.
-- 




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 23:55:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 18:55:38 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTj8j-00045L-VR
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 18:55:38 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RTj8h-00045E-Lr
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 18:55:36 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RTj7A-0000Vk-Vn; Thu, 24 Nov 2011 18:54:01 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Stelian Iancu <stelian.iancu@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
	<CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
X-Spook: mania freedom Israel Uzi offensive information warfare
X-Ran: 4d]#8xD:\>Hey`Aft{)n:d1*#)]VN&qE8:A_q8Cphoi}^(o7oHZjLOE6<UM=X[rQDr"Ka?
X-Hue: white
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Thu, 24 Nov 2011 18:54:00 -0500
In-Reply-To: <CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
	(Stelian Iancu's message of "Thu, 24 Nov 2011 23:55:48 +0100")
Message-ID: <lvaa7l2i1z.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: Eli Zaretskii <eliz@HIDDEN>, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Stelian Iancu wrote:

> I am sorry to be asking a stupid question, but then, wouldn't restart
> Emacs fix the issue and have the new compiled org files loaded?

No, because the files get compiled with a mix of old and new code
loaded, so the compiled files are probably messed up. Restarting Emacs
would not help with that. (You'll definitely need to restart Emacs if
you had one version of Org loaded and want to switch to another.)




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 23:47:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 18:47:49 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTj18-0003tj-TE
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 18:47:47 -0500
Received: from mail-ey0-f172.google.com ([209.85.215.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <stelian.iancu@HIDDEN>) id 1RTiEi-0002i1-Np
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 17:57:45 -0500
Received: by eabm6 with SMTP id m6so477298eab.3
	for <10125 <at> debbugs.gnu.org>; Thu, 24 Nov 2011 14:56:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type;
	bh=LqVthzAUNw4ksCynZ9Qz/fBS8X0nGmblx2cvxlBsoiA=;
	b=fgGy8a27GSXHDbxwjmvzP8HO6IDXaT8ks4Ulsm21qtc9rvyB9UcQxaZd1yKfnGaRHD
	Kx7POxx0NLsHu/Mx0LVNV4pS1/JeJvtlMBccZsnT8oaNwUazkK62H3DJTeV+bQI0jCol
	L7sDkSZUvz8j4FpJE77NfkxPZ/FHudpcGoqlQ=
Received: by 10.213.8.205 with SMTP id i13mr2145590ebi.39.1322175370500; Thu,
	24 Nov 2011 14:56:10 -0800 (PST)
MIME-Version: 1.0
Received: by 10.213.20.17 with HTTP; Thu, 24 Nov 2011 14:55:48 -0800 (PST)
In-Reply-To: <v062i9tk0d.fsf@HIDDEN>
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
From: Stelian Iancu <stelian.iancu@HIDDEN>
Date: Thu, 24 Nov 2011 23:55:48 +0100
Message-ID: <CAKvLAoiAgzjDVpnUpOqyJ1NAuN9O-t4e+P0WVuFtZkEKOp0ZgQ@HIDDEN>
Subject: Re: bug#10125: 24.0.91; package.el (org): Macros in tar packages &
	order of byte compilation
To: Glenn Morris <rgm@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 10125
X-Mailman-Approved-At: Thu, 24 Nov 2011 18:47:45 -0500
Cc: Eli Zaretskii <eliz@HIDDEN>, 10125 <at> debbugs.gnu.org,
	Jambunathan K <kjambunathan@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

On Thu, Nov 24, 2011 at 20:09, Glenn Morris <rgm@HIDDEN> wrote:
> Jambunathan K wrote:
>
>> When compiling with package manager, the compilation happens from within
>> a running Emacs session and very likely the "old" Org files are already
>> loaded in to the runtime "inadvertently" by the user either by looking
>> at the org agenda for the day or may be by just viewing an Org file or
>> by the plain old (require 'org-whatever) out of habit in .emacs.
>
> There's your problem. The only way to reliably compile, especially
> something where an old version might already be loaded, is to use a
> fresh Emacs instance. There's no reason the "package manager" could not
> spawn a separate Emacs in batch-mode as a sub-job to do the compilation.
>
> cc-mode tries to have some voodoo to get around this, but please, please
> don't go down that road.
>
> I guess nobody ever expected the package manager to be used to load a
> different version of something that was already in Emacs.
>

I am sorry to be asking a stupid question, but then, wouldn't restart
Emacs fix the issue and have the new compiled org files loaded? In my
case, that didn't seem to happen either (even though load-library
showed org-compat to be from ELPA).




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 19:54:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 14:54:41 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTfNZ-0006vz-5U
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 14:54:41 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RTfNV-0006vq-Nw
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 14:54:39 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RTfM0-0004GC-6R; Thu, 24 Nov 2011 14:53:04 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Jambunathan K <kjambunathan@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN> <v062i9tk0d.fsf@HIDDEN>
X-Spook: ammunition JSOFC3IP Abu Ghraib domestic disruption TWA
X-Ran: -#s'\}Ix;]fG>*L#;08Oo2K=]odt|%e#-0I:-QV?iXGRMn]4%/#ftf(_7@g$IGcp}6I05j
X-Hue: magenta
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Thu, 24 Nov 2011 14:53:04 -0500
In-Reply-To: <v062i9tk0d.fsf@HIDDEN> (Glenn Morris's message of
	"Thu, 24 Nov 2011 14:09:38 -0500")
Message-ID: <hffwhdqov3.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, 10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Glenn Morris wrote:

> fresh Emacs instance. There's no reason the "package manager" could not
> spawn a separate Emacs in batch-mode as a sub-job to do the compilation.

Very lightly tested version:

*** lisp/emacs-lisp/package.el	2011-11-20 03:48:53 +0000
--- lisp/emacs-lisp/package.el	2011-11-24 19:48:49 +0000
***************
*** 595,600 ****
--- 595,612 ----
  	(error "Package does not untar cleanly into directory %s/" dir))))
    (tar-untar-buffer))
  
+ (defun package-compile (directory)
+   "Compile the Lisp files in DIRECTORY."
+   (with-current-buffer (get-buffer-create "*package-compile*")
+     (goto-char (point-max))
+     (pop-to-buffer (current-buffer))
+     (or (zerop (call-process "emacs" nil t t "--batch" "--eval"
+ 			     (format
+ 			      "(progn (setq load-path (cons \"%s\" load-path))
+                                 (batch-byte-recompile-directory 0))" directory)
+ 			     directory))
+ 	(error "Compiling the package gave an error"))))
+ 
  (defun package-unpack (name version)
    (let* ((dirname (concat (symbol-name name) "-" version))
  	 (pkg-dir (expand-file-name dirname package-user-dir)))
***************
*** 603,610 ****
      (let* ((default-directory (file-name-as-directory package-user-dir)))
        (package-untar-buffer dirname)
        (package-generate-autoloads (symbol-name name) pkg-dir)
!       (let ((load-path (cons pkg-dir load-path)))
! 	(byte-recompile-directory pkg-dir 0 t)))))
  
  (defun package--write-file-no-coding (file-name)
    (let ((buffer-file-coding-system 'no-conversion))
--- 615,621 ----
      (let* ((default-directory (file-name-as-directory package-user-dir)))
        (package-untar-buffer dirname)
        (package-generate-autoloads (symbol-name name) pkg-dir)
!       (package-compile pkg-dir))))
  
  (defun package--write-file-no-coding (file-name)
    (let ((buffer-file-coding-system 'no-conversion))
***************
*** 645,652 ****
  	 pkg-file
  	 nil nil nil 'excl))
        (package-generate-autoloads file-name pkg-dir)
!       (let ((load-path (cons pkg-dir load-path)))
! 	(byte-recompile-directory pkg-dir 0 t)))))
  
  (defmacro package--with-work-buffer (location file &rest body)
    "Run BODY in a buffer containing the contents of FILE at LOCATION.
--- 656,662 ----
  	 pkg-file
  	 nil nil nil 'excl))
        (package-generate-autoloads file-name pkg-dir)
!       (package-compile pkg-dir))))
  
  (defmacro package--with-work-buffer (location file &rest body)
    "Run BODY in a buffer containing the contents of FILE at LOCATION.





Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 19:11:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 14:11:15 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTehW-0005sY-PS
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 14:11:15 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1RTehU-0005sP-DH
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 14:11:13 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1RTefy-0001el-Nn; Thu, 24 Nov 2011 14:09:38 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Jambunathan K <kjambunathan@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
	<81ipm9l9kd.fsf@HIDDEN>
X-Spook: Waco, Texas Fortezza Putin Kosovo USCOI NASA Area 51
X-Ran: <U0BUm;>l]IyXU)ipz!@=+@JG<Hl_$=../Fe]=:,oP\9a&*-<GiG}EKwwSgr)H,Ko,!"67
X-Hue: green
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Thu, 24 Nov 2011 14:09:38 -0500
In-Reply-To: <81ipm9l9kd.fsf@HIDDEN> (Jambunathan K.'s message of "Thu, 24
	Nov 2011 22:52:26 +0530")
Message-ID: <v062i9tk0d.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 10125
Cc: stelian.iancu@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
	10125 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.4 (------)

Jambunathan K wrote:

> When compiling with package manager, the compilation happens from within
> a running Emacs session and very likely the "old" Org files are already
> loaded in to the runtime "inadvertently" by the user either by looking
> at the org agenda for the day or may be by just viewing an Org file or
> by the plain old (require 'org-whatever) out of habit in .emacs. 

There's your problem. The only way to reliably compile, especially
something where an old version might already be loaded, is to use a
fresh Emacs instance. There's no reason the "package manager" could not
spawn a separate Emacs in batch-mode as a sub-job to do the compilation.

cc-mode tries to have some voodoo to get around this, but please, please
don't go down that road.

I guess nobody ever expected the package manager to be used to load a
different version of something that was already in Emacs.




Information forwarded to bug-gnu-emacs@HIDDEN, emacs-orgmode@HIDDEN:
bug#10125; Package emacs,org-mode. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 17:24:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 12:24:28 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTd2C-0003MX-7b
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 12:24:28 -0500
Received: from mail-iy0-f172.google.com ([209.85.210.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTd26-0003MN-KP
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 12:24:24 -0500
Received: by iaeo4 with SMTP id o4so3228097iae.3
	for <10125 <at> debbugs.gnu.org>; Thu, 24 Nov 2011 09:22:50 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=from:to:cc:subject:in-reply-to:references:user-agent:date
	:message-id:mime-version:content-type;
	bh=Rd2zdtAzDBv16ZEngfYiNsBXnRfdS3in6OnQi4Y29so=;
	b=JBVUJ6Js5erHJcf/33c+0wH2nzZ7cqZtCF8jgo3cIW5dmsIraK//5zHR/YlFv+YjVu
	iEfF/sYoUh73VnO2IagyCA2JNfguZly9w7GJVfE1iqd07UlpLXjSKMBrTjzw7c95Va6Z
	QGrpp7nUecufp5KpNd6m34grQYoArdh3T8mqc=
Received: by 10.43.50.67 with SMTP id vd3mr8209152icb.10.1322155369990;
	Thu, 24 Nov 2011 09:22:49 -0800 (PST)
Received: from JAMBU-NETBOOK ([115.241.120.62])
	by mx.google.com with ESMTPS id dd36sm89486894ibb.7.2011.11.24.09.22.42
	(version=TLSv1/SSLv3 cipher=OTHER);
	Thu, 24 Nov 2011 09:22:49 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
In-Reply-To: <E1RTYzR-00039k-Q6@HIDDEN> (Eli Zaretskii's message of
	"Thu, 24 Nov 2011 08:05:21 -0500")
References: <81pqgh90sp.fsf@HIDDEN> <E1RTYzR-00039k-Q6@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.91 (windows-nt)
Date: Thu, 24 Nov 2011 22:52:26 +0530
Message-ID: <81ipm9l9kd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -3.9 (---)
X-Debbugs-Envelope-To: 10125
Cc: emacs-orgmode@HIDDEN, 10125 <at> debbugs.gnu.org, stelian.iancu@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.8 (---)


> Org Mode files certainly have no dependency rules in lisp/Makefile.in.

The Makefile - in devel repo of Orgmode - does define rules. Read on ...

> So the question why the problem does not happen while compiling Org in
> Emacs remains.

I believe the way the files are compiled makes a substantial difference.

When compiling with makefiles:

The compilation happens with *minimal* emacs and in batch mode.

--8<---------------cut here---------------start------------->8---
BATCH=$(EMACS) -batch -q -no-site-file -eval                             	
  "(setq load-path (cons (expand-file-name \"./lisp/\") 
  (cons \"$(lispdir)\" load-path)))"
--8<---------------cut here---------------end--------------->8---

As can be seen above, any (require 'something) of macro files in the
compiled elisp file has to be loaded from the development version
itself.

Furthermore there are dependencies like this in the Makefile:

--8<---------------cut here---------------start------------->8---
lisp/org.elc:		lisp/org-macs.el lisp/org-compat.el lisp/org-faces.el
lisp/org-agenda.elc:	lisp/org.el
--8<---------------cut here---------------end--------------->8---

(I believe removing the dependencies from the Makefiles will still do
the right thing because of the require directives in the compiled files
will load the development version and not the system version)

When compiling with package manager, the compilation happens from within
a running Emacs session and very likely the "old" Org files are already
loaded in to the runtime "inadvertently" by the user either by looking
at the org agenda for the day or may be by just viewing an Org file or
by the plain old (require 'org-whatever) out of habit in .emacs. 

While reporting macro issues, users never say whether they were already
running Org when they were trying to fetch and compile a new Org. They
think it is immaterial. I believe it matters

If "old" org and hence "old" org-macs is already loaded in the
environment when the package is installed, any subsequent (require
'something) will be essentially no-ops. (Can you confirm this?)

What ideally should happen is that during package compilation, a require
should *forcibly* load from the compiled package and not merely check
for availability of a feature symbol.

>> 2. While building from ELPA, the compilation order seems to be
>> alphabetical. So the files get compiled bass ackwards. For example,
>> org-macs.el gets compiled after org-agenda.el.
>> 
>> In summary, there needs to be a way to specify the order in which files
>> are compiled in a multifile tar.
>
> This was discussed several time, in the context of recompiling
> multiple Lisp files while building Emacs, and the decision till now
> was to ignore the issue.  While at least in principle one could write
> a Lisp program that would analyze the various `require' and `load'
> calls (possibly as side effect of byte compilation, like GCC does),
> and generate Makefile rules with correct prerequisites, this is a
> non-trivial project.

I have tried giving an explanation in the earlier paragraph.

> One simple band-aid is to remove all the *.elc files before
> byte-compiling after resync.  This prolongs the compilation, but the
> results are predictably correct.

We are talking of "automatic" compilation by package manager. What you
say applies to hand compilation via makefiles.

>> A supplementary question to (2):
>> 
>> During the package compilation, when encountering (require
>> 'some-org-library-with-macros) does the library get loaded from *within*
>> the tarball or from the *emacs core*.
>
> Whichever is found first along load-path, I think.  See `openp'.

What does package manager do?
-- 




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10125; Package emacs. Full text available.

Message received at 10125 <at> debbugs.gnu.org:


Received: (at 10125) by debbugs.gnu.org; 24 Nov 2011 13:06:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 08:06:57 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTZ0z-0005lQ-5J
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 08:06:57 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <eliz@HIDDEN>) id 1RTZ0v-0005lH-AY
	for 10125 <at> debbugs.gnu.org; Thu, 24 Nov 2011 08:06:55 -0500
Received: from eliz by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <eliz@HIDDEN>)
	id 1RTYzR-00039k-Q6; Thu, 24 Nov 2011 08:05:21 -0500
Date: Thu, 24 Nov 2011 08:05:21 -0500
Message-Id: <E1RTYzR-00039k-Q6@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jambunathan K <kjambunathan@HIDDEN>
In-reply-to: <81pqgh90sp.fsf@HIDDEN> (message from Jambunathan K on Thu, 24
	Nov 2011 17:42:38 +0530)
Subject: Re: bug#10125: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
References: <81pqgh90sp.fsf@HIDDEN>
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 10125
Cc: emacs-orgmode@HIDDEN, 10125 <at> debbugs.gnu.org, stelian.iancu@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

> From: Jambunathan K <kjambunathan@HIDDEN>
> Date: Thu, 24 Nov 2011 17:42:38 +0530
> Cc: emacs-orgmode@HIDDEN, Stelian Iancu <stelian.iancu@HIDDEN>
> 
> 1. While building via Makefile, there is an implicit dependency that is
> *enforced* via make rules and files with macro definitions are compiled
> ahead of their consumers.

That's not true: there are no dependencies defined in lisp/Makefile.in
in the Emacs source tree for Lisp files, with a very few exceptions.
Org Mode files certainly have no dependency rules in lisp/Makefile.in.
So the question why the problem does not happen while compiling Org in
Emacs remains.

> 2. While building from ELPA, the compilation order seems to be
> alphabetical. So the files get compiled bass ackwards. For example,
> org-macs.el gets compiled after org-agenda.el.
> 
> In summary, there needs to be a way to specify the order in which files
> are compiled in a multifile tar.

This was discussed several time, in the context of recompiling
multiple Lisp files while building Emacs, and the decision till now
was to ignore the issue.  While at least in principle one could write
a Lisp program that would analyze the various `require' and `load'
calls (possibly as side effect of byte compilation, like GCC does),
and generate Makefile rules with correct prerequisites, this is a
non-trivial project.

One simple band-aid is to remove all the *.elc files before
byte-compiling after resync.  This prolongs the compilation, but the
results are predictably correct.

> A supplementary question to (2):
> 
> During the package compilation, when encountering (require
> 'some-org-library-with-macros) does the library get loaded from *within*
> the tarball or from the *emacs core*.

Whichever is found first along load-path, I think.  See `openp'.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10125; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Nov 2011 12:14:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 24 07:14:57 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RTYCd-0003pE-KY
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 07:14:55 -0500
Received: from eggs.gnu.org ([140.186.70.92])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTYCa-0003p6-Qo
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 07:14:53 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTYB2-000710-6s
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 07:13:21 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.6 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_LOW,T_DKIM_INVALID autolearn=unavailable version=3.3.1
Received: from lists.gnu.org ([140.186.70.17]:56842)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTYB2-00070w-54
	for submit <at> debbugs.gnu.org; Thu, 24 Nov 2011 07:13:16 -0500
Received: from eggs.gnu.org ([140.186.70.92]:56182)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTYB0-0005W8-SV
	for bug-gnu-emacs@HIDDEN; Thu, 24 Nov 2011 07:13:16 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <kjambunathan@HIDDEN>) id 1RTYAv-0006zh-5q
	for bug-gnu-emacs@HIDDEN; Thu, 24 Nov 2011 07:13:14 -0500
Received: from mail-iy0-f169.google.com ([209.85.210.169]:37716)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kjambunathan@HIDDEN>)
	id 1RTYAl-0006xu-E9; Thu, 24 Nov 2011 07:12:59 -0500
Received: by iaek3 with SMTP id k3so3939994iae.0
	for <multiple recipients>; Thu, 24 Nov 2011 04:12:58 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=from:to:cc:subject:date:message-id:mime-version:content-type;
	bh=m6+pmAdPY8V3YwxU7YkYcgWXYTaI35AosRi78Z4TCJU=;
	b=RHWbBeb7oPDczjLSCeZkzry8NHPCswRKhpa+VOPUL8G5N+gD3EaOWkMg8+AXif49dF
	HzPW6rieSDPf7La9QFzioxuaNEM92CDQR4qPj5J3doDb+BF+FmrKbvENaEoSNrizsfpz
	6kOV2FNpbmiOKXA8MqgRYE7nv0QrRBa+juN1o=
Received: by 10.42.202.17 with SMTP id fc17mr7063681icb.15.1322136778047;
	Thu, 24 Nov 2011 04:12:58 -0800 (PST)
Received: from JAMBU-NETBOOK ([115.184.91.150])
	by mx.google.com with ESMTPS id ai7sm48407478igc.0.2011.11.24.04.12.51
	(version=TLSv1/SSLv3 cipher=OTHER);
	Thu, 24 Nov 2011 04:12:56 -0800 (PST)
From: Jambunathan K <kjambunathan@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.0.91;
	package.el (org): Macros in tar packages & order of byte compilation
Date: Thu, 24 Nov 2011 17:42:38 +0530
Message-ID: <81pqgh90sp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 2)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 140.186.70.17
X-Spam-Score: -4.9 (----)
X-Debbugs-Envelope-To: submit
Cc: Stelian Iancu <stelian.iancu@HIDDEN>, emacs-orgmode@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.9 (----)


There have been constant flow of issues from users who install daily org
tar balls from GNU ELPA.

The problem concerns itself with the defmacros that are introduced in
the *daily* tar but are *unavailable* in the *emacs* core. At the end of
the package installation these new macros never get recognized as macros
and gets compiled in as function calls. This triggers crashes at a later
stage.

Note that there are no such defmacro issues that get reported from users
who install org from git repo using conventional make and make install.

The crux of the issue is this:

1. While building via Makefile, there is an implicit dependency that is
*enforced* via make rules and files with macro definitions are compiled
ahead of their consumers.

2. While building from ELPA, the compilation order seems to be
alphabetical. So the files get compiled bass ackwards. For example,
org-macs.el gets compiled after org-agenda.el.

In summary, there needs to be a way to specify the order in which files
are compiled in a multifile tar.

A supplementary question to (2):

During the package compilation, when encountering (require
'some-org-library-with-macros) does the library get loaded from *within*
the tarball or from the *emacs core*.

I hope this description is sufficient. I can cite actual posts from
orgmode mailing list if additional information is needed.










Acknowledgement sent to Jambunathan K <kjambunathan@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#10125; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 15 Aug 2015 17:30:05 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.